/**
 * @file exo_ahw_al_ext_flash_stub.c
 *
 * @brief This file contains abstracted stub functions for external flash memories
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "exo_ahw_al_ext_flash_common.h"
#include "exo_ahw_al_ext_flash_wrapper.h"
#include "exo_ahw_al_common.h"
#include <stdlib.h>

#ifndef __weak
   #define __weak   __attribute__((weak))
#endif /* __weak */

__weak hal_ret_sts ahw_al_ext_mem_driver_init(ahw_inst_id_t ext_mem_id)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_ext_mem_write(ahw_inst_id_t ahw_id, uint32_t address, uint8_t *data, uint32_t size)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_ext_mem_erase_and_write(ahw_inst_id_t ahw_id, uint32_t address, uint8_t *data, uint32_t size)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_ext_mem_read(ahw_inst_id_t ahw_id, uint32_t address, uint8_t *data, uint32_t size)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_ext_mem_erase(ahw_inst_id_t ahw_id, uint32_t start_address, uint32_t end_address)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_ext_mem_enable_memory_map(ahw_inst_id_t ahw_id)
{
	return HAL_DRIVER_DISABLED;
}






