/**
 * @file exo_ahw_al_hsc_stub.c
 *
 * @brief This file contains abstracted stubs function for hotswap controller and voltage ,current monitor
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "exo_ahw_al_hsc_common.h"
#include "exo_ahw_al_hsc_wrapper.h"
#include <stdio.h>

#ifndef __weak
   #define __weak   __attribute__((weak))
#endif /* __weak */

__weak hal_ret_sts ahw_al_hsc_init(ahw_al_hsc_hdl* hsc_arg, ahw_inst_id_t ahw_id)
{
	return HAL_DRIVER_DISABLED;
	}

__weak hal_ret_sts ahw_al_hsc_deinit(ahw_al_hsc_hdl* hsc_arg, ahw_inst_id_t ahw_id)
{
	return HAL_DRIVER_DISABLED;
	}

__weak hal_ret_sts ahw_al_hsc_read_voltage(uint32_t ahw_id, float *voltage )
{
	return HAL_DRIVER_DISABLED;
	}
__weak hal_ret_sts ahw_al_hsc_read_current(uint32_t ahw_id, float *current)
{
	return HAL_DRIVER_DISABLED;
	}
__weak hal_ret_sts ahw_al_hsc_get_hotswap_sts(uint32_t ahw_id, uint8_t *hotswap_sts)
{
	return HAL_DRIVER_DISABLED;
	}
__weak hal_ret_sts ahw_al_hsc_hotswap_control(uint32_t ahw_id, uint8_t on_off)
{
	return HAL_DRIVER_DISABLED;
	}
__weak hal_ret_sts ahw_al_hsc_get_overcurrent_sts(uint32_t ahw_id, uint8_t *under_vlt_sts)
{
	return HAL_DRIVER_DISABLED;

}

