/*
 * @file exo_ahw_al_thruster_stub.c
 *
 * @brief This file checks stub state of the sensor
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <stdlib.h>
#include "exo_ahw_al_thruster_common.h"


#ifndef __weak
   #define __weak   __attribute__((weak))
#endif /* __weak */

#if 0
__weak hal_ret_sts ahw_al_thruster_init()
{
	return HAL_DRIVER_DISABLED;
}
#endif
__weak hal_ret_sts ahw_al_thruster_unit_set_frc(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,float force)
{
	return HAL_DRIVER_DISABLED;
}
__weak hal_ret_sts ahw_al_thruster_reset(ahw_al_thruster_hdle *h_thruster)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_boot(ahw_al_thruster_hdle *h_thruster)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_unit_set_pwr_on_off(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t on_off)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_unit_set_mode(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t mode)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_set_mode(ahw_al_thruster_hdle *h_thruster,uint8_t system_id)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_mode(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *mode)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_unit_get_mode(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *mode)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_sys_sts(ahw_al_thruster_hdle *h_thruster, uint8_t system_id,al_thruster_sts *info)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_sys_srl_num(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *srl_num)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_housekeeping1_data(ahw_al_thruster_hdle *h_thruster,al_thruster_housekeeping1 *info)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_housekeeping2_data(ahw_al_thruster_hdle *h_thruster,al_thruster_housekeeping2 *info,uint8_t system_id)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_housekeeping3_data(ahw_al_thruster_hdle *h_thruster,uint8_t *housekeeping3)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_unit_get_pwr_on_off(ahw_al_thruster_hdle *h_thruster,uint8_t *on_off,uint8_t system_id)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_unit_get_frc(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *frc)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_mst_time(ahw_al_thruster_hdle *h_thruster,uint32_t *mst_tm)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_bckplane_temp(ahw_al_thruster_hdle *h_thruster,uint8_t* bckpln_temp)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_bckplane_tot_frc(ahw_al_thruster_hdle *h_thruster,uint16_t* bckpln_frc)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_tot_azimth_ang(ahw_al_thruster_hdle *h_thruster,uint16_t* tot_azmth)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_tot_polar_ang(ahw_al_thruster_hdle *h_thruster,uint8_t *tot_plr)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_tot_pwr_cnsp(ahw_al_thruster_hdle *h_thruster,uint16_t *pwr_cnsp)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_unreg_vol(ahw_al_thruster_hdle *h_thruster,uint8_t *unreg_vol)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_remn_prplt(ahw_al_thruster_hdle *h_thruster,uint16_t *prplt)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_unit_polar_ang(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *polar)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_unit_azimth_ang(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *azimuthal)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_unit_pwr(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *power)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_rst_sts(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *rst_sts)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_tot_pwr(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *pwr)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_unreg_volt(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *unreg_vol)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_dev_on_sts(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *dev_sts)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_unit_rst_sts(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *rst_sts)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_brd_temp(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *temp)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_unit_prplt(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *prplt)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_ureg_volt(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *unreg_vol)
{
	return HAL_DRIVER_DISABLED;
}
__weak hal_ret_sts ahw_al_thruster_get_calib(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint32_t *calib)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_heat_err_code(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *err_cde)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_heat_duty_cycle(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *duty_cycle)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_heat_temp(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,int8_t *temp)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_heat_trg_temp(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,int8_t *trgt_temp)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_emit_volt(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *emt_vol)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_emit_cur(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *emt_cur)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_emit_inp_cur(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *emt_ip_cur)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_ext_volt(ahw_al_thruster_hdle *h_thruster,uint8_t ext_id,uint8_t system_id,uint16_t *ext_vol)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_ext_cur(ahw_al_thruster_hdle *h_thruster,uint8_t ext_id,uint8_t system_id,uint16_t *ext_cur)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_ext_inp_cur(ahw_al_thruster_hdle *h_thruster,uint8_t ext_id,uint8_t system_id,uint16_t *ext_ip_cur)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_neutlr_volt(ahw_al_thruster_hdle *h_thruster,uint8_t neut_id,uint8_t system_id,uint16_t *neut_vol)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_neutlr_cur(ahw_al_thruster_hdle *h_thruster,uint8_t neut_id,uint8_t system_id,uint16_t *neut_cur)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_neutlr_inp_cur(ahw_al_thruster_hdle *h_thruster,uint8_t neut_id,uint8_t system_id,uint16_t *neut_ip_cur)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_neutlr_retn_cur(ahw_al_thruster_hdle *h_thruster,uint8_t neut_id,uint8_t system_id,uint16_t *neut_ret_cur)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_mjr_vers_no(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *mjr_vers_no)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_mnr_vers_no(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *mnr_vers_no)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_patch_vers_no(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint16_t *ptch_vers_no)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_brd_err_cde(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *err_cde)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_err_count(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint8_t *err_count)
{
	return HAL_DRIVER_DISABLED;
}

__weak hal_ret_sts ahw_al_thruster_get_strt_time(ahw_al_thruster_hdle *h_thruster,uint8_t system_id,uint32_t *strt_time)
{
	return HAL_DRIVER_DISABLED;
}



