#ifndef DRIVERS_EXO_HAL_DRIVER_FW_EXO_AHW_AL_DRIVER_API_EXO_AHW_AL_WRAPPER_INC_EXO_AHW_AL_DL_H_
#define DRIVERS_EXO_HAL_DRIVER_FW_EXO_AHW_AL_DRIVER_API_EXO_AHW_AL_WRAPPER_INC_EXO_AHW_AL_DL_H_

#include "exo_hal_common.h"
#include "exo_ahw_al_data_logger_common.h"



/**
 * @brief Mapping function to get the data from the specified channel number
 * @param[in] al_ad7291 - instance pointer of data acquisition device
 * @param[in] chnl - selects the channel of ads7828
 * @param[in] pd_opt - power down option
 * @param[out] data - pointer to a data
 * @retval hal_ret_sts - returns the success or error code
 */
hal_ret_sts ahw_al_dl_common_init(ahw_al_ad7291_hdl* al_dl_h);

hal_ret_sts ahw_al_dl_common_get_voltage_convertion(ahw_al_ad7291_hdl* al_dl_h, adc_channel_id chnl, float *data);

#endif
