/*
 * @file exo_io_al_linux_adc.h
 *
 * @brief This file contains linux wrapper functions declarations for IO interface
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef DRIVERS_EXO_HAL_DRIVER_FW_EXO_IO_AL_DRIVER_API_EXO_IO_AL_WRAPPER_EXO_IO_AL_LINUX_EXO_IO_AL_LINUX_ADC_C_
#define DRIVERS_EXO_HAL_DRIVER_FW_EXO_IO_AL_DRIVER_API_EXO_IO_AL_WRAPPER_EXO_IO_AL_LINUX_EXO_IO_AL_LINUX_ADC_C_

#include "exo_hal_common.h"
#include "exo_io_al_adc_common.h"


hal_ret_sts io_hal_linux_adc_init(ioal_adc_hdle *ioal_hadc);
hal_ret_sts io_hal_linux_adc_start(ioal_adc_hdle *hadc);
hal_ret_sts io_hal_linux_adc_pollforconversion(ioal_adc_hdle *hadc, uint32_t Timeout);
hal_ret_sts io_hal_linux_adc_getvalue(ioal_adc_hdle *hadc);
hal_ret_sts io_hal_linux_adc_stop(ioal_adc_hdle *hadc);

#define io_hal_common_adc_init                                io_hal_linux_adc_init
#define io_hal_common_adc_start                               io_hal_linux_adc_start
#define io_hal_common_adc_pollforconversion                   io_hal_linux_adc_pollforconversion
#define io_hal_common_adc_getvalue                            io_hal_linux_adc_getvalue
#define io_hal_common_adc_stop                                io_hal_linux_adc_stop

#endif /* DRIVERS_EXO_HAL_DRIVER_FW_EXO_IO_AL_DRIVER_API_EXO_IO_AL_WRAPPER_EXO_IO_AL_LINUX_EXO_IO_AL_LINUX_ADC_C_ */
