/*
 * @file exo_io_al_linux_crc.c
 *
 * @brief This file contains wrapper function definition for I2C interface
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "exo_io_al_linux_crc.h"
#include "exo_common.h"
#include "exo_hal_io_al_common.h"

/*
 * @brief This API is use to Initialization Linux CRC.
 */
hal_ret_sts io_hal_linux_crc_init(ioal_crc_hdle *ioal_hcrc)
{
	return HAL_SCS;
}

/*
 * @brief This API is use to determine the input data format for Linux CRC.
 */
hal_ret_sts io_hal_linux_crc_calculation (ioal_crc_hdle *ioal_hcrc, uint8_t *input_data_buffer, uint32_t input_data_buffer_size, uint32_t *crc_output_value)
{
	return HAL_SCS;
}


