/**
 * @file log_adcs.h
 *
 * @brief This file contains logger enumeration values for the module ADCS
 *
 */


/* Note: header guard format should not be changed */
#ifndef _LOG_ADCS_H_
#define _LOG_ADCS_H_




/* User has to update enum list */
#define ADCS_FOREACH_LOG(ADCS_LOG_NAME) 							\
        ADCS_LOG_NAME(Total_retry__eq__u16_)   							\
        ADCS_LOG_NAME(Values__s16__pt__s8_)  						\
        ADCS_LOG_NAME(Xpos__u32__cm__Ypos__u32__cm__Zpos__u32__)   			\
        ADCS_LOG_NAME(detumbling_started__u8__cm__u16__cm__u16__cm__u32_)  	\
        ADCS_LOG_NAME(Level__u32_)             \
        ADCS_LOG_NAME(STATE_MACHINE_FAILURE)                      \
        ADCS_LOG_NAME(STATUS_OF_ADCS_RESET__u8_)                      \
        ADCS_LOG_NAME(STATUS_OF_ADCS_BOOT__u8_)                      \
        ADCS_LOG_NAME(STATUS_OF_ADCS_SENSOR__u8_)                      \
        ADCS_LOG_NAME(STATUS_OF_ADCS_ACTUATOR__u8_)                      \
        ADCS_LOG_NAME(STATUS_OF_ADCS_DETUMBLE__u8_)                      \
        ADCS_LOG_NAME(STATUS_OF_ADCS_COARSE_MOMENTUM__u8_)                      \
        ADCS_LOG_NAME(STATUS_OF_ADCS_FINE_MOMENTUM__u8_)                      \
        ADCS_LOG_NAME(STATUS_OF_ADCS_SHUTDOWN__u8_)                      \
        ADCS_LOG_NAME(STATUS_OF_ADCS_TEST__u8_)                      \
        ADCS_LOG_NAME(RESET_FAIL_EVENT)                      \
        ADCS_LOG_NAME(RESET_DONE_STATE)                      \
        ADCS_LOG_NAME(LOG_BOOT_INIT_DONE)                      \
        ADCS_LOG_NAME(LOG_BOOT_INIT_FAIL)                      \
        ADCS_LOG_NAME(LOG_FINE_MOMENTUM_DONE)                      \
        ADCS_LOG_NAME(LOG_FINE_MOMENTUM_FAIL)                      \
        ADCS_LOG_NAME(LOG_COARSE_MOMENTUM_DONE)                      \
        ADCS_LOG_NAME(LOG_COARSE_MOMENTUM_FAIL)                      \
        ADCS_LOG_NAME(LOG_SENSOR_INIT_DONE)                      \
        ADCS_LOG_NAME(LOG_SENSOR_INIT_FAIL)                \
        ADCS_LOG_NAME(STARTING_TO_DETUMBLE)                                        \
        ADCS_LOG_NAME(Waiting_600_sec)                                        \
        ADCS_LOG_NAME(RATE_TO_REDUCE_600S_DLY)                                        \
        ADCS_LOG_NAME(Failed_to_acquire_telemetry_in_final_detumbling_setp)                                        \
        ADCS_LOG_NAME(Final_detumbling_success)                                        \
        ADCS_LOG_NAME(Rates_failed_to_reduce_in_final_detumbling_step_wait_another_600s)                                        \
        ADCS_LOG_NAME(Angular_rates_failed_to_reduce_in_initial_detumbling_step)                                        \
        ADCS_LOG_NAME(Failed_to_acquire_telemetry_in_initial_detumbling_step)                                        \
        ADCS_LOG_NAME(Failed_to_acquire_telemetry_before_starting_Zthomson_spin)                                        \
        ADCS_LOG_NAME(Gyro_EKF_est_rates_not_match_with_actual_rates)                                        \
        ADCS_LOG_NAME(Set_Gyro_EKF_est_mode_failed)                                        \
        ADCS_LOG_NAME(Masking_sens_for_est_failed)                                        \
        ADCS_LOG_NAME(Starting_reaction_wheel_test)                                        \
        ADCS_LOG_NAME(Set_ctrl_mode_to_none_failed)                                        \
        ADCS_LOG_NAME(_Masking_sens_for_est_failed)                                        \
        ADCS_LOG_NAME(Coarse_momentum_failed)                                        \
        ADCS_LOG_NAME(Mems_rate_analysis_failed_for_conXYZwheel)                                        \
        ADCS_LOG_NAME(Set_ctrl_mode_to_conXYZwheel_failed)                                        \
        ADCS_LOG_NAME(Reaction_wheel_tests_failed)                                        \
        ADCS_LOG_NAME(Set_ctrl_mode_to_suntrack_failed)                                        \
        ADCS_LOG_NAME(Fine_momentum_sucess)                                        \
        ADCS_LOG_NAME(ADCS_COMMISSIONING_SUCCESS)                                        \
        ADCS_LOG_NAME(Enabling_the_usage_of_sun_sens_in_est_mode_failed)                                        \
        ADCS_LOG_NAME(sun_or_nadir_sens_commissioning_failed)                                        \
        ADCS_LOG_NAME(star_sens_commissioning_failed)                                        \
        ADCS_LOG_NAME(Powering_sun_camer_failed)                                        \
        ADCS_LOG_NAME(Req_tm_failed_in_test_fine_sun_sens)                                        \
        ADCS_LOG_NAME(Powering_nadir_camer_failed)                                        \
        ADCS_LOG_NAME(Nadir_Y_angle_is_not_close_to_zero)                                        \
        ADCS_LOG_NAME(Nadir_X_angle_is_not_close_to_zero)                                        \
        ADCS_LOG_NAME(Pwr_star_trck_failed)                                        \
        ADCS_LOG_NAME(Star_trck_cfg_change_needed)                                        \
        ADCS_LOG_NAME(NO_Star_identified)                                        \
        ADCS_LOG_NAME(NO_Star_detected)                                        \
        ADCS_LOG_NAME(NO_Star_image_captured)                                        \
        ADCS_LOG_NAME(Req_raw_star_tm_failed)                                        \
        ADCS_LOG_NAME(Zwheel_test_is_success)                                        \
        ADCS_LOG_NAME(Zwheel_test_is_failed)                                        \
        ADCS_LOG_NAME(Xwheel_test_is_success)                                        \
        ADCS_LOG_NAME(Xwheel_test_is_failed)                                        \
        ADCS_LOG_NAME(Ywheel_test_is_failed)                                        \
        ADCS_LOG_NAME(Failed_to_turn_on_R_Wheel)                                        \
        ADCS_LOG_NAME(Failed_to_cmd_Wheel_Z_speed)                                        \
        ADCS_LOG_NAME(Failed_to_obtain_rate_tm_in_R__Wheel_test)                                        \
        ADCS_LOG_NAME(Rates_not_match_in_R_Wheel_test)                                        \
        ADCS_LOG_NAME(Failed_to_cmd_Wheel_R_speed_to_0_RPM)                                        \
        ADCS_LOG_NAME(ADCS_SENDTC_CAN_API_RETURNS_FAILURE_FOR_RATE_GYRO_CFG)                                        \
        ADCS_LOG_NAME(Set_est_params_failed)                                        \
        ADCS_LOG_NAME(osmalloc_failed_for_TC_in_set_est_param)                                        \
        ADCS_LOG_NAME(Req_est_params_tlm_failed)                                        \
        ADCS_LOG_NAME(osmalloc_failed_for_TLM_in_set_est_param)                                        \
        ADCS_LOG_NAME(Req_tlm_failed_in_test_ang_rate_measure)                                        \
        ADCS_LOG_NAME(OSmalloc_failed_in_req_identification_tlm)                                        \
        ADCS_LOG_NAME(Rate_sens_rates_tlm_test)                                        \
        ADCS_LOG_NAME(OSmalloc1_failed_in_req_rate_sens_rates_tlm)                                        \
        ADCS_LOG_NAME(Rate_Sensor_Estimated_Rates_Telemetry_test)                                        \
        ADCS_LOG_NAME(OSmalloc2_failed_in_req_rate_sens_rates_tlm)                                        \
        ADCS_LOG_NAME(Rate_Sensor_Gyro_cfg_Tlm_test)                                        \
        ADCS_LOG_NAME(OSmalloc_failed_in_req_gyro_cfg)                                        \
        ADCS_LOG_NAME(Nadir_TLM_Test)                                        \
        ADCS_LOG_NAME(OSmalloc1_failed_in_req_nadir_vec_tlm)                                        \
        ADCS_LOG_NAME(Coarse_sun_TLM_Test)                                        \
        ADCS_LOG_NAME(OSmalloc2_failed_in_req_nadir_vec_tlm)                                     \
        ADCS_LOG_NAME(Fine_sun_TLM_Test)                                    \
        ADCS_LOG_NAME(OSmalloc_failed_in_req_fine_sun_tlm)                                        \
        ADCS_LOG_NAME(OSmalloc_failed_in_req_raw_star_tlm)                                        \
        ADCS_LOG_NAME(Test_command_failed)                                        \
        ADCS_LOG_NAME(Test_success)                                        \
        ADCS_LOG_NAME(Max_rate__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(max_rate_a_detumble_rateX__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(max_rate_b_detumble_rateX__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(max_rate_a_detumble_rateY__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(max_rate_b_detumble_rateY__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(max_rate_a_detumble_rateZ__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(ang_max_rate_X__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(ang_max_rate_Y__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(ang_max_rate_Z__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(rateX_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(rateY_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(rateZ_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(Est_rateX_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(Est_rateY_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(Est_rateZ_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(NadirX_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(NadirY_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(NadirZ_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(cssX_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(cssY_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(cssZ_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(sunX_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(sunY_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(sunZ_is__u32__pt__u32_)                                        \
        ADCS_LOG_NAME(Adcs_selected_detumbling_ctrl_mode__u32_)                                        \
        ADCS_LOG_NAME(Failed1_to_set_control_mode__u32__in_initial_detumbling)                                        \
        ADCS_LOG_NAME(Failed2_to_set_control_mode__u32__in_initial_detumbling)                                        \
        ADCS_LOG_NAME(Failed3_to_set_control_mode__u32__in_initial_detumbling)                                        \
        ADCS_LOG_NAME(No_of_stars_identified)                                        \
        ADCS_LOG_NAME(Error_recv_TLM_in_req_rate_sens_rate_tlm__s32_)                                        \
        ADCS_LOG_NAME(Error_recv_TLM_in_req_rate_sens_rates_tlm__s32_)                                        \
        ADCS_LOG_NAME(gyro_cfg_RateSensMult__u32_)                                        \
        ADCS_LOG_NAME(Error_recv_TLM_in_req_gyro_cfg__s32_)                                        \
        ADCS_LOG_NAME(Error_recv_TLM_in_req_nadir_vec_tlm__s32_)                                        \
        ADCS_LOG_NAME(Error_recv_TLM_in_req_css_tlm__s32_)                                        \
        ADCS_LOG_NAME(Error_recv_TLM_in_req_fine_sun_tlm__s32_)                                        \
        ADCS_LOG_NAME(imageCaptureSuccess_is__u8_)                                        \
        ADCS_LOG_NAME(detectionSuccess_is_u8_)                                        \
        ADCS_LOG_NAME(identificationSuccess_is_u8_)                                        \
        ADCS_LOG_NAME(Error_recv_TLM_in_req_raw_star_tlm__s32_)                                        \
	ADCS_LOG_NAME(Error_recv_tlm_in_req_identification_tlm_i8_)                 \
	ADCS_LOG_NAME(Error_recv_tlm__i8_)                        \
	ADCS_LOG_NAME(Error_receving_tlm_s32)                      \
        ADCS_LOG_NAME(Received_RESET_REQUEST_Command)       \
        ADCS_LOG_NAME(Received_BOOT_INIT_REQUEST_Command)       \
        ADCS_LOG_NAME(Received_SENSOR_INIT_REQUEST_Command)       \
        ADCS_LOG_NAME(Received_ACTUATOR_INIT_REQUEST_Command)       \
        ADCS_LOG_NAME(Received_DETUMBLE_REQUEST_Command)       \
        ADCS_LOG_NAME(Received_COARSE_MOMENTUM_REQUEST_Command)       \
        ADCS_LOG_NAME(Received_FINE_MOMENTUM_REQUEST_Command)       \
        ADCS_LOG_NAME(Received_SHUTDOWN_RQST_Command)       \
        ADCS_LOG_NAME(Received_TEST_RQST_Command)       \
        ADCS_LOG_NAME(Sending_boot_init_request)       \
        ADCS_LOG_NAME(BOOT_INIT_DONE_state)       \
        ADCS_LOG_NAME(Sending_sensor_init_request)       \
        ADCS_LOG_NAME(BOOT_INIT_FAIL_EVENT)       \
        ADCS_LOG_NAME(SENSOR_INIT_DONE_state)       \
        ADCS_LOG_NAME(sending_ACTUATOR_INIT_REQUEST)       \
        ADCS_LOG_NAME(SENSOR_INIT_FAIL_event)       \
        ADCS_LOG_NAME(ACTUATOR_INIT_DONE_state)       \
        ADCS_LOG_NAME(sending_DETUMBLE_REQUEST)       \
        ADCS_LOG_NAME(ACTUATOR_INIT_FAIL_event)       \
        ADCS_LOG_NAME(DETUMBLE_DONE_state)       \
        ADCS_LOG_NAME(sending_COARSE_MOMENTUM_REQUEST)       \
        ADCS_LOG_NAME(DETUMBLE_FAIL_event)       \
        ADCS_LOG_NAME(COARSE_MOMENTUM_DONE_state)       \
        ADCS_LOG_NAME(sending_FINE_MOMENTUM_REQUEST)       \
        ADCS_LOG_NAME(COARSE_MOMENTUM_FAIL_event)       \
        ADCS_LOG_NAME(FINE_MOMENTUM_DONE_event)         \
        ADCS_LOG_NAME(FINE_MOMENTUM_FAIL_event)          \
        ADCS_LOG_NAME(sending_SHUTDOWN_request)          \
        ADCS_LOG_NAME(sending_TEST_request)\
        ADCS_LOG_NAME(FINALIZE_UPLOAD_BLOCK_SUCCESS) \
        ADCS_LOG_NAME(INTERNAL_FLASH_COPY_SUCCESS) \
        ADCS_LOG_NAME(Flash_Erase_Success) \
        ADCS_LOG_NAME(Flash_Upload_Initiated) \
        ADCS_LOG_NAME(Hole_Map) \
        ADCS_LOG_NAME(Firmware_upload_failed) \
        ADCS_LOG_NAME(Boot_Success) \
        ADCS_LOG_NAME(Boot_Failed) \
        ADCS_LOG_NAME(FTM_NOR_data_not_avail_checksumFail) \
        ADCS_LOG_NAME(FTM_NOR_data_not_avail) \
        ADCS_LOG_NAME(FTM_SDRAM_flash_callback_called) \
        ADCS_LOG_NAME(FTM_SDRAM_flash_CRC_pass) \
        ADCS_LOG_NAME(FTM_SDRAM_flash_CRC_fail) \
        ADCS_LOG_NAME(FTM_saveontext_NOR_flash_CRC_PASS) \
        ADCS_LOG_NAME(FTM_saveontext_NOR_flash_CRC_FAIL) \
        ADCS_LOG_NAME(FTM_saveontext_NOR_memcpy_FAIL) \
        ADCS_LOG_NAME(INTG_Buffer_ptr_Null) \
        ADCS_LOG_NAME(ADCS_FW_copied_at_NOR_Fail) \
        ADCS_LOG_NAME(ADCS_FW_copied_at_memcpy_Fail) \
        ADCS_LOG_NAME(FTM_for_ADCS_module_notification_API_invoked) \
        ADCS_LOG_NAME(download_success) \
        ADCS_LOG_NAME(Transfer_mode_FILE) \
        ADCS_LOG_NAME(download_failed__cm__CRC_error) \
        ADCS_LOG_NAME(download_suspended_by_sender_Timeout_mode) \
        ADCS_LOG_NAME(Auto_Save_Context_Mode_activated) \
        ADCS_LOG_NAME(Manual_Save_Context_Mode_activated) \
        ADCS_LOG_NAME(FTM_SCT_100_per_completed) \
        ADCS_LOG_NAME(NOR_copy_initiated) \
        ADCS_LOG_NAME(NOR_copy_not_initiated) \
        ADCS_LOG_NAME(Invalid_case) \
        ADCS_LOG_NAME(dwnld_resumed_by_sender) \
        ADCS_LOG_NAME(dwnld_resumed_back_by_sender) \
        ADCS_LOG_NAME(Dwnld_Resume_Savecontext_mode_Req_by_Sender) \
        ADCS_LOG_NAME(Resume_Savecontext_mode_Bulkdata_selected) \
        ADCS_LOG_NAME(Dwnld_req_recv_for_EPS) \
        ADCS_LOG_NAME(Transfer_mode_DATA) \
        ADCS_LOG_NAME(dwnld_Terminated_by_Recv_node) \
        ADCS_LOG_NAME(suspend_timeout_req_not_completed) \
        ADCS_LOG_NAME(suspend_savecontext_req_not_completed) \
        ADCS_LOG_NAME(resume_timeout_req_not_completed) \
        ADCS_LOG_NAME(resume_savecontext_req_not_completed) \
        ADCS_LOG_NAME(Invalid_Notification_not_processed) \
        ADCS_LOG_NAME(END) \
        ADCS_LOG_NAME(ADCS_FTM_REGISTRATION) \
        ADCS_LOG_NAME(Firmware_upload_initialized_flash_index__u8_) \
        ADCS_LOG_NAME(Block_length__u32__Remaining_length__u32_) \
        ADCS_LOG_NAME(FTM_savecontext_NOR_flash_callback_called_fail) \
        ADCS_LOG_NAME(FTM_savecontext_NOR_flash_callback_called) \
        ADCS_LOG_NAME(FTM_savecontext_NOR_cpy_nvm_store_discarded) \
        ADCS_LOG_NAME(ADCS_FW_copied_in_NOR_at_Address_0x_hex_of_Size_u32_kb) \
        ADCS_LOG_NAME(File_size__u32__cm__NOR_copy_initiated) \
        ADCS_LOG_NAME(dwnld_suspended_by_sender_save_context_mode) \
        ADCS_LOG_NAME(context_data_size__u16_) \
        ADCS_LOG_NAME(dwnld_terminated_due_to_suspend_timeout_expired) \
        ADCS_LOG_NAME(dwnld_suspend_timeout_mode_accepted_by_sender) \
        ADCS_LOG_NAME(Mem_addr_passing_0x_u32_x_of_size__u32_) \
        ADCS_LOG_NAME(Resume_SaveContext_Error__u8_) \
        ADCS_LOG_NAME(dwnld_Resume_Savecontext_mode_Accepted_by_Sender) \
        ADCS_LOG_NAME(FT_Missing_PCKT_COUNT__u32_) \
        ADCS_LOG_NAME(File_name__s8_) \
        ADCS_LOG_NAME(Malloc_req__u16_) \
        ADCS_LOG_NAME(File_size__u32_) \
        ADCS_LOG_NAME(hole_map)        \
        ADCS_LOG_NAME(ADCS_TC_TM_ID__u8__STATUS__s8_) \
        ADCS_LOG_NAME(ADCS_LOG_MAX)


#define ADCS_GENERATE_ENUM(ENUM) ENUM,
#define ADCS_GENERATE_STRING(STRING) #STRING,

typedef enum log_adcs_e_
{
	ADCS_FOREACH_LOG(ADCS_GENERATE_ENUM)
}log_adcs_e;



#endif /* _LOG_ADCS_H_ */
