/**
 * @file log_eps.h
 *
 * @brief This file contains logger enumeration values for the module EPS
 *
 */


/* Note: header guard format should not be changed */
#ifndef _LOG_EPS_H_
#define _LOG_EPS_H_



/* User has to update enum list */
#define EPS_FOREACH_LOG(EPS_LOG_NAME) 		\
        EPS_LOG_NAME(EPS_INIT)   			\
        EPS_LOG_NAME(OBC_APP_ITC_MESSAGE_SEND_FAIL)                         \
        EPS_LOG_NAME(BATTERY_VOLT__u8__pt__u8_)                         \
	EPS_LOG_NAME(EPS_MODE__u8_)                         \
        EPS_LOG_NAME(INVALID_EPS_STATE_INPUT)                         \
        EPS_LOG_NAME(HRM_WAS_TURNING_ON)                         \
        EPS_LOG_NAME(PS_WAS_TURNING_ON)                         \
        EPS_LOG_NAME(GPS_PWR_ERR__u8_)                         \
        EPS_LOG_NAME(HRM_CH_EN_ERR)                         \
        EPS_LOG_NAME(PL_SRVR_PWR_ERR__u8_)                         \
        EPS_LOG_NAME(OBC_PWR_OFF_ERR)                         \
        EPS_LOG_NAME(EDGE_PWR_ERR__u8_)                         \
        EPS_LOG_NAME(S_BAND_PWR_ERR__u8_)                         \
        EPS_LOG_NAME(XBAND_PWR_ERR__u8_)                         \
        EPS_LOG_NAME(PL_TRANS_PWR_ERR__u8_)                         \
		EPS_LOG_NAME(PL_STS300_PWR_ERR__u8_)                         \
		EPS_LOG_NAME(PL_PROP_UNIT_THRUSTER_PWR_ERR__u8_)                         \
		EPS_LOG_NAME(PL_ADCS_PWR_ERR__u8_)                         \
		EPS_LOG_NAME(PL_UHF_PWR_ERR__u8_)                         \
		EPS_LOG_NAME(PL_SCANWAY_PWR_ERR__u8_)                         \
        EPS_LOG_NAME(PL_ZE5_PWR_ERR__u8_)                         \
        EPS_LOG_NAME(PL_NETRA_PWR_ERR__u8_)                         \
        EPS_LOG_NAME(PL_SYRLBS_PWR_ERR__u8_)            			\
		EPS_LOG_NAME(INVALID_CONVERTOR_BOARD_ID)									\
		EPS_LOG_NAME(INVALID_BATTERY_BOARD_ID)									\
		EPS_LOG_NAME(INVALID_OUTPUT_CHANNEL_PARAMETER_ID)									\
		EPS_LOG_NAME(EPS_SIMU_SOCKET_CREATION_FAILED)				\
		EPS_LOG_NAME(EPS_SIMU_SOCKET_SUCCESSFULLY_CREATED)			\
		EPS_LOG_NAME(EPS_SIMU_SOCKET_BIND_FAILED)					\
		EPS_LOG_NAME(EPS_SIMU_SOCKET_SUCCESSFULLY_BINDED)			\
		EPS_LOG_NAME(EPS_LISTEN_FAILED)								\
		EPS_LOG_NAME(EPS_SERVER_LISTENING)							\
		EPS_LOG_NAME(EPS_SERVER_ACCEPT_FAILED)						\
		EPS_LOG_NAME(EPS_SERVER_CLIENT_CONNECTED)					\
		EPS_LOG_NAME(EPS_SIMU_SOCKET_WRITE_FAIL)					\
		EPS_LOG_NAME(EPS_SIMU_SOCKET_READ_FAIL)						\
		EPS_LOG_NAME(EPS_I2C_RD_ERR)								\
		EPS_LOG_NAME(EPS_I2C_WR_ERROR)								\
		EPS_LOG_NAME(BTRY_REQ_OP_CH__u8__STATE__u8_)					\
		EPS_LOG_NAME(BTRY_CH_MAP_ERR_CH_u8_BTRY_u8_)                \
		EPS_LOG_NAME(FW_BOOT_STARTUP_SUCCESS)                          \
		EPS_LOG_NAME(FW_BOOT_STARTUP_FAIL_PID1__hex__PID2__hex__INVALID)                          \
		EPS_LOG_NAME(FW_IMPROPER_COMMAND)                              \
        EPS_LOG_NAME(FW_NACK_FOR_DATA_READ_COMMAND__hex_)                              \
        EPS_LOG_NAME(FW_READ_NOT_SUCCESS_FOR_COMMAND__hex_)                              \
        EPS_LOG_NAME(FW_NACK_RECEIVED_FOR_ERASE_SECTOR)                              \
        EPS_LOG_NAME(FW_SECTOR_ID_TRANSMIT_FAIL)                              \
        EPS_LOG_NAME(FW_NACK_RECEIVED_FOR_SECTOR_COUNT_TRANSMIT)                              \
        EPS_LOG_NAME(FW_NACK_RECEIVED_FOR_WRITE)                              \
        EPS_LOG_NAME(FW_DATA_FRAME_TRANSMIT_FAILED)                              \
        EPS_LOG_NAME(FW_READ_MEMORY_FAILURE)                              \
        EPS_LOG_NAME(FW_NACK_RECEIVED_FOR_READ_LENGTH_FRAME)                              \
        EPS_LOG_NAME(FW_READ_LENGTH_FRAME_TRANSMIT_FAILED)                              \
        EPS_LOG_NAME(FW_SECTOR_COUNT_TRANSMIT_FAIL)                              \
		EPS_LOG_NAME(FW_GO_COMMAND_SUCCESSFUL)                              \
        EPS_LOG_NAME(FW_RECEIVED_NACK_FOR_COMMAND__hex_)                              \
        EPS_LOG_NAME(FW_COMMAND_REJECTED__hex_)                              \
        EPS_LOG_NAME(FW_RECEIVED_NACK_FOR_ADDRESS_FRAME)                              \
        EPS_LOG_NAME(FW_ADDRESS_FRAME_TRANSMIT_FAILED)                              \
        EPS_LOG_NAME(FW_WRITE_ADDRESS_NOT_ALIGNED_IN_4BYTES_WRITE_FAIL)                              \
		EPS_LOG_NAME(FW_READ_ADDRESS_NOT_ALIGNED_IN_4BYTES_READ_FAIL)                              \
        EPS_LOG_NAME(FW_FIRMWARE_LOADING_SUCCESS)                              \
        EPS_LOG_NAME(FW_FIRMWARE_LOADING_FAILURE)                              \
        EPS_LOG_NAME(FW_ERASE_SECTORS_SUCCESSFUL)                              \
        EPS_LOG_NAME(FW_READ_AND_WRITE_DATA_MATCH_SUCCESS)                              \
        EPS_LOG_NAME(FW_READ_AND_WRITE_DATA_MATCH_FAIL)                              \
		EPS_LOG_NAME(FW_EPS_FTM_REGISTRATION)                              \
        EPS_LOG_NAME(FW_MEMCOPY_FROM_NOR_TO_SDRAM_FAIL)                              \
        EPS_LOG_NAME(FW_UPDATE_PASS)                               \
        EPS_LOG_NAME(FW_COPIED_AT_NOR_FAIL)                               \
        EPS_LOG_NAME(FW_DOWNLOAD_SUCCESS)                               \
        EPS_LOG_NAME(FW_DOWNLOAD_REQUEST_RECEIVED_FOR_EPS)                               \
        EPS_LOG_NAME(FW_EPS_COPIED_AT_ADDRESS__hex__OF_SIZE__u32_)                    \
		EPS_LOG_NAME(EPS_SET_CONV_BRD_PARAM_SUCCESS)                               \
		EPS_LOG_NAME(EPS_SET_BTRY_BRD_PARAM_SUCCESS)                             \
		EPS_LOG_NAME(EPS_SET_CHNL_CURRENT_LIMIT_PARAM_SUCCESS)                  \
		EPS_LOG_NAME(EPS_SET_MODE_PARAMS_SUCCESS)                                \
		EPS_LOG_NAME(EPS_SET_CHNL_STATE_SUCCESS)                              \
		EPS_LOG_NAME(NETRA_HW_STS_PWR_ON)                                     \
		EPS_LOG_NAME(NETRA_HW_STS_PWR_OFF)                                    \
		EPS_LOG_NAME(TRANSCELESTIAL_HW_STS_PWR_ON)                           \
		EPS_LOG_NAME(TRANSCELESTIAL_HW_STS_PWR_OFF)                          \
		EPS_LOG_NAME(PL_STS300_HW_STS_PWR_ON)                                \
		EPS_LOG_NAME(PL_STS300_HW_STS_PWR_OFF)                              \
		EPS_LOG_NAME(ADCS_HW_STS_PWR_ON)                                     \
		EPS_LOG_NAME(ADCS_HW_STS_PWR_OFF)                                     \
		EPS_LOG_NAME(THRUSTER_HW_STS_PWR_ON)                                \
		EPS_LOG_NAME(THRUSTER_HW_STS_PWR_OFF)                               \
		EPS_LOG_NAME(X_BAND_HW_STS_PWR_ON)                                   \
		EPS_LOG_NAME(X_BAND_HW_STS_PWR_OFF)                                   \
		EPS_LOG_NAME(S_BAND_HW_STS_PWR_ON)                                     \
		EPS_LOG_NAME(S_BAND_HW_STS_PWR_OFF)                                   \
		EPS_LOG_NAME(EDGE_BRD_HW_STS_PWR_ON)                                  \
		EPS_LOG_NAME(EDGE_BRD_HW_STS_PWR_OFF)                                   \
		EPS_LOG_NAME(PS_BRD_HW_STS_PWR_ON)										\
		EPS_LOG_NAME(PS_BRD_HW_STS_PWR_OFF)											\
		EPS_LOG_NAME(GPS_BRD_HW_STS_PWR_ON)												\
		EPS_LOG_NAME(GPS_BRD_HW_STS_PWR_OFF)										\
		EPS_LOG_NAME(EPS_CH_u8_PWR_STS_U8_SRC_ID_u8_)								\
		EPS_LOG_NAME(EPS_GET_BTRY_BOARD_PARAM_READ_SUCCESS)									\
		EPS_LOG_NAME(EPS_GET_CONV_BOARD_PARAM_READ_SUCCESS)									\
		EPS_LOG_NAME(EPS_GET_CHNL_BOARD_PARAM_READ_SUCCESS)                                                               \
		EPS_LOG_NAME(PL_UHF_HW_STS_PWR_OFF)										\
		EPS_LOG_NAME(PL_UHF_HW_STS_PWR_ON)										\
		EPS_LOG_NAME(PL_SCANWAY_HW_STS_PWR_OFF)								\
		EPS_LOG_NAME(PL_SCANWAY_HW_STS_PWR_ON)								\
		EPS_LOG_NAME(EPS_FW_VERSION_MISMATCH_ERR)								\
		EPS_LOG_NAME(EPS_MCU1_FW_SIZE_OR_CRC_FAIL)								\
		EPS_LOG_NAME(EPS_MCU2_FW_SIZE_OR_CRC_FAIL)								\
		EPS_LOG_NAME(EPS_INVALID_MCU_TYPE)								\
		EPS_LOG_NAME(EPS_MCU1_SEC_FW_VERS__u8_pt_u8_pt_u8)								\
		EPS_LOG_NAME(EPS_MCU2_SEC_FW_VERS__u8_pt_u8_pt_u8)								\
		EPS_LOG_NAME(EPS_MCU1_SEC_FW_VERS_BCKUP_FW__u8_pt_u8_pt_u8)								\
		EPS_LOG_NAME(EPS_MCU2_SEC_FW_VERS_BCKUP_FW__u8_pt_u8_pt_u8)								\
		EPS_LOG_NAME(EPS_FW_BOOT_STARTUP_FAIL)								\
		EPS_LOG_NAME(EPS_FW_UPDATE_FAILED)								\
		EPS_LOG_NAME(EPS_DOWNLOADED_FIRMWARE_INTEGRITY_FAIL)								\
		EPS_LOG_NAME(FW_SIZE_0R_CRC_MISMATCH)								\
		EPS_LOG_NAME(EPS_FW_NOT_AVAILABLE)								\
		EPS_LOG_NAME(EPS_BCKUP_FW_INTR_FAIL)								\
		EPS_LOG_NAME(EPS_BCKUP_FW_NOT_AVAILABLE)								\
		EPS_LOG_NAME(BCKUP_FW_MEMCOPY_FROM_NOR_TO_SDRAM_FAIL)								\
		EPS_LOG_NAME(EPS_BCKUP_FW_UPDATE_FAILED)								\
		EPS_LOG_NAME(EPS_BCKUP_FW_BOOT_STARTUP_FAIL)								\
		EPS_LOG_NAME(EPS_MCU2_INCORRECT_FW_UPLOADED_BCKUP_FW_TRIGGERED)								\
		EPS_LOG_NAME(EPS_MCU2_BCKUP_FW_VERS__u8_pt_u8_pt_u8)								\
		EPS_LOG_NAME(EPS_MCU2_FW_UPLOAD_FAILED_BCKUP_FW_TRIGGERED)								\
		EPS_LOG_NAME(EPS_SET_OBC_COM_FAIL_RST_TIMEOUT_SUCCESS)								\
                EPS_LOG_NAME(EPS_LOG_MAX)





#define EPS_GENERATE_ENUM(ENUM) ENUM,
#define EPS_GENERATE_STRING(STRING) #STRING,

typedef enum log_eps_e_
{
	EPS_FOREACH_LOG(EPS_GENERATE_ENUM)
}log_eps_e;

#endif /* _LOG_EPS_H_ */
