/**
 * @file log_logger.h
 *
 * @brief This file contains logger enumeration values for the module MODULENAME
 *
 *  This is a template file to be followed to include new modules in logger software component
 *
 */


/* Note: header guard format should not be changed;
 * valid way to represent header guard should be "_LOG_<your module name>_H_" example: _LOG_ADCS_H_
 * */
#ifndef _LOG_LOGGER_H_
#define _LOG_LOGGER_H_




/* User has to update enumeration member list */
#define LOGGER_FOREACH_LOG(LOGGER_LOG_NAME) 				                \
        LOGGER_LOG_NAME(NEW_BLOCK_ID___u16__START_ON__u8___u8___u16_)       \
		LOGGER_LOG_NAME(NVM_FRAMEWORK_LOAD_FAIL)                            \
        LOGGER_LOG_NAME(NVM_LOCATION_A_LOAD_FAIL)                           \
        LOGGER_LOG_NAME(NVM_DEFAULT_LOAD_SUCCESS)                           \
        LOGGER_LOG_NAME(NVM_DEFAULT_LOAD_FAIL)                              \
        LOGGER_LOG_NAME(NVM_LOCATION_A_LOAD_SUCCESS)                        \
        LOGGER_LOG_NAME(NVM_FRAMEWORK_LOAD_SUCCESS)                         \
        LOGGER_LOG_NAME(NVM_FLASH_COMMIT_END)                               \
        LOGGER_LOG_NAME(LOGGER_LOG_MAX)



#define LOGGER_GENERATE_ENUM(ENUM) ENUM,
#define LOGGER_GENERATE_STRING(STRING) #STRING,

typedef enum log_logger_e_
{
	LOGGER_FOREACH_LOG(LOGGER_GENERATE_ENUM)
}log_logger_e;



#endif /* _LOG_LOGGER_H_ */
