/**
 * @file log_obc.h
 *
 * @brief This file contains logger enumeration values for the module OBC
 *
 */


/* Note: header guard format should not be changed */
#ifndef _LOG_OBC_H_
#define _LOG_OBC_H_


/* User has to update enum list */
#define OBC_FOREACH_LOG(OBC_LOG_NAME) 		\
        OBC_LOG_NAME(OBC_INIT)   			\
		OBC_LOG_NAME(OBC_RECEIVE_NULL_ERROR)    \
        OBC_LOG_NAME(IN_MAIN_CH__u8_)           \
		OBC_LOG_NAME(DATA__u8_)             \
        OBC_LOG_NAME(DATA__u16_)          \
        OBC_LOG_NAME(SEND__u8_)            \
        OBC_LOG_NAME(TESTING)          \
		OBC_LOG_NAME(OTSU_RESET)         \
		OBC_LOG_NAME(FORCE_SW_RESET)       \
		OBC_LOG_NAME(IN_TC_DEFERRED_STRG)   \
        OBC_LOG_NAME(MEM_TYPE__u8_)          \
        OBC_LOG_NAME(OPERATION__u8_)          \
		OBC_LOG_NAME(SET_RADIO_ID__u8_)        \
		OBC_LOG_NAME(INVALID_TC_ID_RECEIVED__u16_)     \
		OBC_LOG_NAME(OBC_MAIN_ENTRY__u8_)          \
		OBC_LOG_NAME(OBC_MAIN_EXIT__u8_)               \
                OBC_LOG_NAME(OBC_LOG_MAX)





#define OBC_GENERATE_ENUM(ENUM) ENUM,
#define OBC_GENERATE_STRING(STRING) #STRING,

typedef enum log_obc_e_
{
	OBC_FOREACH_LOG(OBC_GENERATE_ENUM)
}log_obc_e;

#endif /* _LOG_OBC_H_ */
