/**
 * @file adcs_cube_bypass.h
 *
 * @brief This file contains function prototypes and types
 *        that are needed for bypass state/mode functionality
 *
 * @copyright Copyright 2023 Antaris, Inc.
 */
/*********************************************************************/
#ifndef ADCS_CUBE_BYPASS_H_
#define ADCS_CUBE_BYPASS_H_

#include <stdio.h>
#include "adcs_bootloader.h"
#include "adcs_va.h"
#include "exo_osal_mem_management.h"
#include "adcs_comm_interface.h"
#include "adcs_common.h"
#include "adcs_cubeacp.h"
#include "adcs_vapi_common.h"
#include "exo_types.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @brief Internal test function to test the interface
 *
 * @return status of the test
 * @retval Greater than or equal to zero -> Success
 *         Less than zero -> Error
 */
int32 adcs_test_bypass();

#ifdef __cplusplus
}
#endif
#endif /* ADCS_CUBE_BYPASS_H_ */
