/*
 * Copyright (c) 2017-2022 Satlab A/S <satlab@satlab.com>
 * All rights reserved. Do not distribute without permission.
 *
 * Properties for Satlab SRS-4 S-band radio version 1.5.0
 *
 * Autogenerated from srs4_props.json on 2022-10-05 17:04:27
 * Please do not edit manually.
 */

#include <prop_spec.h>

#ifndef __SL_PROPS_SRS4_H__
#define __SL_PROPS_SRS4_H__

/* sys: System properties */
#define SL_SRS4_PROP_SYS_GROUP_ID 5
#define SL_SRS4_PROP_SYS_GROUP PROP_MKGROUPID(SL_SRS4_PROP_SYS_GROUP_ID)

/* sys.name: String name for system */
#define SL_SRS4_PROP_SYS_NAME_PROP_ID 5
#define SL_SRS4_PROP_SYS_NAME PROP_MKID(PROP_TYPE_STRING, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_NAME_PROP_ID)
#define SL_SRS4_PROP_SYS_NAME_DEF_VAL "srs-4"
#define SL_SRS4_PROP_SYS_NAME_SIZE 20
#define SL_SRS4_PROP_SYS_NAME_FMT NULL
#define SL_SRS4_PROP_SYS_NAME_UNIT NULL

/* sys.serial: Serial number/ID */
#define SL_SRS4_PROP_SYS_SERIAL_PROP_ID 9
#define SL_SRS4_PROP_SYS_SERIAL PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_SERIAL_PROP_ID)
#define SL_SRS4_PROP_SYS_SERIAL_DEF_VAL 0
#define SL_SRS4_PROP_SYS_SERIAL_MIN_VAL 0
#define SL_SRS4_PROP_SYS_SERIAL_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_SYS_SERIAL_FMT "%08x"
#define SL_SRS4_PROP_SYS_SERIAL_UNIT NULL

/* sys.sw.version: Running software version */
#define SL_SRS4_PROP_SYS_SW_VERSION_PROP_ID 10
#define SL_SRS4_PROP_SYS_SW_VERSION PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_SW_VERSION_PROP_ID)
#define SL_SRS4_PROP_SYS_SW_VERSION_DEF_VAL 0
#define SL_SRS4_PROP_SYS_SW_VERSION_MIN_VAL 0
#define SL_SRS4_PROP_SYS_SW_VERSION_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_SYS_SW_VERSION_FMT "%08x"
#define SL_SRS4_PROP_SYS_SW_VERSION_UNIT NULL

/* sys.bootcount: Number of times the system was booted */
#define SL_SRS4_PROP_SYS_BOOTCOUNT_PROP_ID 12
#define SL_SRS4_PROP_SYS_BOOTCOUNT PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_BOOTCOUNT_PROP_ID)
#define SL_SRS4_PROP_SYS_BOOTCOUNT_DEF_VAL 0
#define SL_SRS4_PROP_SYS_BOOTCOUNT_MIN_VAL 0
#define SL_SRS4_PROP_SYS_BOOTCOUNT_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_SYS_BOOTCOUNT_FMT NULL
#define SL_SRS4_PROP_SYS_BOOTCOUNT_UNIT NULL

/* sys.reboot: Reboot timer */
#define SL_SRS4_PROP_SYS_REBOOT_PROP_ID 13
#define SL_SRS4_PROP_SYS_REBOOT PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_REBOOT_PROP_ID)
#define SL_SRS4_PROP_SYS_REBOOT_DEF_VAL 0
#define SL_SRS4_PROP_SYS_REBOOT_MIN_VAL 0
#define SL_SRS4_PROP_SYS_REBOOT_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_SYS_REBOOT_FMT NULL
#define SL_SRS4_PROP_SYS_REBOOT_UNIT "s"

/* sys.gwdt.init: GWDT timer reset value */
#define SL_SRS4_PROP_SYS_GWDT_INIT_PROP_ID 15
#define SL_SRS4_PROP_SYS_GWDT_INIT PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_GWDT_INIT_PROP_ID)
#define SL_SRS4_PROP_SYS_GWDT_INIT_DEF_VAL 86400
#define SL_SRS4_PROP_SYS_GWDT_INIT_MIN_VAL 0
#define SL_SRS4_PROP_SYS_GWDT_INIT_MAX_VAL 604800
#define SL_SRS4_PROP_SYS_GWDT_INIT_FMT NULL
#define SL_SRS4_PROP_SYS_GWDT_INIT_UNIT "s"

/* sys.gwdt.counter: GWDT current counter value */
#define SL_SRS4_PROP_SYS_GWDT_COUNTER_PROP_ID 16
#define SL_SRS4_PROP_SYS_GWDT_COUNTER PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_GWDT_COUNTER_PROP_ID)
#define SL_SRS4_PROP_SYS_GWDT_COUNTER_DEF_VAL 0
#define SL_SRS4_PROP_SYS_GWDT_COUNTER_MIN_VAL 0
#define SL_SRS4_PROP_SYS_GWDT_COUNTER_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_SYS_GWDT_COUNTER_FMT NULL
#define SL_SRS4_PROP_SYS_GWDT_COUNTER_UNIT "s"

/* sys.gwdt.reset: GWDT reset trigger */
#define SL_SRS4_PROP_SYS_GWDT_RESET_PROP_ID 17
#define SL_SRS4_PROP_SYS_GWDT_RESET PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_GWDT_RESET_PROP_ID)
#define SL_SRS4_PROP_SYS_GWDT_RESET_DEF_VAL 0
#define SL_SRS4_PROP_SYS_GWDT_RESET_MIN_VAL 0
#define SL_SRS4_PROP_SYS_GWDT_RESET_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_SYS_GWDT_RESET_FMT "%08x"
#define SL_SRS4_PROP_SYS_GWDT_RESET_UNIT NULL

/* sys.csp.address: CSP address of the device */
#define SL_SRS4_PROP_SYS_CSP_ADDRESS_PROP_ID 20
#define SL_SRS4_PROP_SYS_CSP_ADDRESS PROP_MKID(PROP_TYPE_UINT8, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_CSP_ADDRESS_PROP_ID)
#define SL_SRS4_PROP_SYS_CSP_ADDRESS_DEF_VAL 24
#define SL_SRS4_PROP_SYS_CSP_ADDRESS_MIN_VAL 0
#define SL_SRS4_PROP_SYS_CSP_ADDRESS_MAX_VAL 30
#define SL_SRS4_PROP_SYS_CSP_ADDRESS_FMT NULL
#define SL_SRS4_PROP_SYS_CSP_ADDRESS_UNIT NULL

/* sys.csp.routes: CSP routing table in CIDR notation */
#define SL_SRS4_PROP_SYS_CSP_ROUTES_PROP_ID 21
#define SL_SRS4_PROP_SYS_CSP_ROUTES PROP_MKID(PROP_TYPE_STRING, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_CSP_ROUTES_PROP_ID)
#define SL_SRS4_PROP_SYS_CSP_ROUTES_DEF_VAL "0/0 CAN,10/5 SPACE"
#define SL_SRS4_PROP_SYS_CSP_ROUTES_SIZE 100
#define SL_SRS4_PROP_SYS_CSP_ROUTES_FMT NULL
#define SL_SRS4_PROP_SYS_CSP_ROUTES_UNIT NULL

/* sys.can.rate: CAN-bus bitrate */
#define SL_SRS4_PROP_SYS_CAN_RATE_PROP_ID 30
#define SL_SRS4_PROP_SYS_CAN_RATE PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_CAN_RATE_PROP_ID)
#define SL_SRS4_PROP_SYS_CAN_RATE_DEF_VAL 1000000
#define SL_SRS4_PROP_SYS_CAN_RATE_MIN_VAL 50000
#define SL_SRS4_PROP_SYS_CAN_RATE_MAX_VAL 1000000
#define SL_SRS4_PROP_SYS_CAN_RATE_FMT NULL
#define SL_SRS4_PROP_SYS_CAN_RATE_UNIT "bps"

/* sys.can.promisc: Accept all CSP CAN-frames */
#define SL_SRS4_PROP_SYS_CAN_PROMISC_PROP_ID 31
#define SL_SRS4_PROP_SYS_CAN_PROMISC PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_CAN_PROMISC_PROP_ID)
#define SL_SRS4_PROP_SYS_CAN_PROMISC_DEF_VAL true
#define SL_SRS4_PROP_SYS_CAN_PROMISC_FMT NULL
#define SL_SRS4_PROP_SYS_CAN_PROMISC_UNIT NULL

/* sys.uart.rate: UART baudrate */
#define SL_SRS4_PROP_SYS_UART_RATE_PROP_ID 40
#define SL_SRS4_PROP_SYS_UART_RATE PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_UART_RATE_PROP_ID)
#define SL_SRS4_PROP_SYS_UART_RATE_DEF_VAL 1000000
#define SL_SRS4_PROP_SYS_UART_RATE_MIN_VAL 9600
#define SL_SRS4_PROP_SYS_UART_RATE_MAX_VAL 12500000
#define SL_SRS4_PROP_SYS_UART_RATE_FMT NULL
#define SL_SRS4_PROP_SYS_UART_RATE_UNIT "bps"

/* sys.uart.multidrop: UART multidrop mode */
#define SL_SRS4_PROP_SYS_UART_MULTIDROP_PROP_ID 41
#define SL_SRS4_PROP_SYS_UART_MULTIDROP PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_UART_MULTIDROP_PROP_ID)
#define SL_SRS4_PROP_SYS_UART_MULTIDROP_DEF_VAL false
#define SL_SRS4_PROP_SYS_UART_MULTIDROP_FMT NULL
#define SL_SRS4_PROP_SYS_UART_MULTIDROP_UNIT NULL

/* sys.net.enable: IP stack enable */
#define SL_SRS4_PROP_SYS_NET_ENABLE_PROP_ID 50
#define SL_SRS4_PROP_SYS_NET_ENABLE PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_NET_ENABLE_PROP_ID)
#define SL_SRS4_PROP_SYS_NET_ENABLE_DEF_VAL false
#define SL_SRS4_PROP_SYS_NET_ENABLE_FMT NULL
#define SL_SRS4_PROP_SYS_NET_ENABLE_UNIT NULL

/* sys.net.en.ip: Ethernet IP address */
#define SL_SRS4_PROP_SYS_NET_EN_IP_PROP_ID 51
#define SL_SRS4_PROP_SYS_NET_EN_IP PROP_MKID(PROP_TYPE_STRING, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_NET_EN_IP_PROP_ID)
#define SL_SRS4_PROP_SYS_NET_EN_IP_DEF_VAL "192.168.100.2"
#define SL_SRS4_PROP_SYS_NET_EN_IP_SIZE 50
#define SL_SRS4_PROP_SYS_NET_EN_IP_FMT NULL
#define SL_SRS4_PROP_SYS_NET_EN_IP_UNIT NULL

/* sys.net.en.prefix: Ethernet network prefix bits */
#define SL_SRS4_PROP_SYS_NET_EN_PREFIX_PROP_ID 52
#define SL_SRS4_PROP_SYS_NET_EN_PREFIX PROP_MKID(PROP_TYPE_UINT8, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_NET_EN_PREFIX_PROP_ID)
#define SL_SRS4_PROP_SYS_NET_EN_PREFIX_DEF_VAL 24
#define SL_SRS4_PROP_SYS_NET_EN_PREFIX_MIN_VAL 1
#define SL_SRS4_PROP_SYS_NET_EN_PREFIX_MAX_VAL 32
#define SL_SRS4_PROP_SYS_NET_EN_PREFIX_FMT NULL
#define SL_SRS4_PROP_SYS_NET_EN_PREFIX_UNIT NULL

/* sys.net.en.gw: Ethernet gateway IP address */
#define SL_SRS4_PROP_SYS_NET_EN_GW_PROP_ID 53
#define SL_SRS4_PROP_SYS_NET_EN_GW PROP_MKID(PROP_TYPE_STRING, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_NET_EN_GW_PROP_ID)
#define SL_SRS4_PROP_SYS_NET_EN_GW_DEF_VAL "192.168.100.1"
#define SL_SRS4_PROP_SYS_NET_EN_GW_SIZE 50
#define SL_SRS4_PROP_SYS_NET_EN_GW_FMT NULL
#define SL_SRS4_PROP_SYS_NET_EN_GW_UNIT NULL

/* sys.net.rf.ip: Spacelink IP address */
#define SL_SRS4_PROP_SYS_NET_RF_IP_PROP_ID 55
#define SL_SRS4_PROP_SYS_NET_RF_IP PROP_MKID(PROP_TYPE_STRING, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_NET_RF_IP_PROP_ID)
#define SL_SRS4_PROP_SYS_NET_RF_IP_DEF_VAL "192.168.200.2"
#define SL_SRS4_PROP_SYS_NET_RF_IP_SIZE 50
#define SL_SRS4_PROP_SYS_NET_RF_IP_FMT NULL
#define SL_SRS4_PROP_SYS_NET_RF_IP_UNIT NULL

/* sys.net.rf.prefix: Spacelink network prefix bits */
#define SL_SRS4_PROP_SYS_NET_RF_PREFIX_PROP_ID 56
#define SL_SRS4_PROP_SYS_NET_RF_PREFIX PROP_MKID(PROP_TYPE_UINT8, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_NET_RF_PREFIX_PROP_ID)
#define SL_SRS4_PROP_SYS_NET_RF_PREFIX_DEF_VAL 24
#define SL_SRS4_PROP_SYS_NET_RF_PREFIX_MIN_VAL 1
#define SL_SRS4_PROP_SYS_NET_RF_PREFIX_MAX_VAL 32
#define SL_SRS4_PROP_SYS_NET_RF_PREFIX_FMT NULL
#define SL_SRS4_PROP_SYS_NET_RF_PREFIX_UNIT NULL

/* sys.net.rf.gw: Spacelink gateway IP address */
#define SL_SRS4_PROP_SYS_NET_RF_GW_PROP_ID 57
#define SL_SRS4_PROP_SYS_NET_RF_GW PROP_MKID(PROP_TYPE_STRING, SL_SRS4_PROP_SYS_GROUP_ID, SL_SRS4_PROP_SYS_NET_RF_GW_PROP_ID)
#define SL_SRS4_PROP_SYS_NET_RF_GW_DEF_VAL "192.168.200.1"
#define SL_SRS4_PROP_SYS_NET_RF_GW_SIZE 50
#define SL_SRS4_PROP_SYS_NET_RF_GW_FMT NULL
#define SL_SRS4_PROP_SYS_NET_RF_GW_UNIT NULL

/* cal: Calibration properties */
#define SL_SRS4_PROP_CAL_GROUP_ID 6
#define SL_SRS4_PROP_CAL_GROUP PROP_MKGROUPID(SL_SRS4_PROP_CAL_GROUP_ID)

/* cal.ps.gain: Power sensor gain */
#define SL_SRS4_PROP_CAL_PS_GAIN_PROP_ID 5
#define SL_SRS4_PROP_CAL_PS_GAIN PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_CAL_GROUP_ID, SL_SRS4_PROP_CAL_PS_GAIN_PROP_ID)
#define SL_SRS4_PROP_CAL_PS_GAIN_DEF_VAL 4.774490573
#define SL_SRS4_PROP_CAL_PS_GAIN_MIN_VAL -FLT_MAX
#define SL_SRS4_PROP_CAL_PS_GAIN_MAX_VAL FLT_MAX
#define SL_SRS4_PROP_CAL_PS_GAIN_FMT NULL
#define SL_SRS4_PROP_CAL_PS_GAIN_UNIT NULL

/* cal.ps.intercept: Power sensor intercept */
#define SL_SRS4_PROP_CAL_PS_INTERCEPT_PROP_ID 6
#define SL_SRS4_PROP_CAL_PS_INTERCEPT PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_CAL_GROUP_ID, SL_SRS4_PROP_CAL_PS_INTERCEPT_PROP_ID)
#define SL_SRS4_PROP_CAL_PS_INTERCEPT_DEF_VAL 0.039190728
#define SL_SRS4_PROP_CAL_PS_INTERCEPT_MIN_VAL -FLT_MAX
#define SL_SRS4_PROP_CAL_PS_INTERCEPT_MAX_VAL FLT_MAX
#define SL_SRS4_PROP_CAL_PS_INTERCEPT_FMT NULL
#define SL_SRS4_PROP_CAL_PS_INTERCEPT_UNIT NULL

/* cal.vctcxo: VCTCXO adjust */
#define SL_SRS4_PROP_CAL_VCTCXO_PROP_ID 10
#define SL_SRS4_PROP_CAL_VCTCXO PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_CAL_GROUP_ID, SL_SRS4_PROP_CAL_VCTCXO_PROP_ID)
#define SL_SRS4_PROP_CAL_VCTCXO_DEF_VAL 1500
#define SL_SRS4_PROP_CAL_VCTCXO_MIN_VAL 0
#define SL_SRS4_PROP_CAL_VCTCXO_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_CAL_VCTCXO_FMT NULL
#define SL_SRS4_PROP_CAL_VCTCXO_UNIT NULL

/* cal.pwr.set: Current pout setpoint */
#define SL_SRS4_PROP_CAL_PWR_SET_PROP_ID 20
#define SL_SRS4_PROP_CAL_PWR_SET PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_CAL_GROUP_ID, SL_SRS4_PROP_CAL_PWR_SET_PROP_ID)
#define SL_SRS4_PROP_CAL_PWR_SET_DEF_VAL 0.0
#define SL_SRS4_PROP_CAL_PWR_SET_MIN_VAL -FLT_MAX
#define SL_SRS4_PROP_CAL_PWR_SET_MAX_VAL FLT_MAX
#define SL_SRS4_PROP_CAL_PWR_SET_FMT "%.2f"
#define SL_SRS4_PROP_CAL_PWR_SET_UNIT "dBm"

/* cal.ber.enable: Enable BER test */
#define SL_SRS4_PROP_CAL_BER_ENABLE_PROP_ID 30
#define SL_SRS4_PROP_CAL_BER_ENABLE PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_CAL_GROUP_ID, SL_SRS4_PROP_CAL_BER_ENABLE_PROP_ID)
#define SL_SRS4_PROP_CAL_BER_ENABLE_DEF_VAL false
#define SL_SRS4_PROP_CAL_BER_ENABLE_FMT NULL
#define SL_SRS4_PROP_CAL_BER_ENABLE_UNIT NULL

/* cal.ber.window: BER window size */
#define SL_SRS4_PROP_CAL_BER_WINDOW_PROP_ID 31
#define SL_SRS4_PROP_CAL_BER_WINDOW PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_CAL_GROUP_ID, SL_SRS4_PROP_CAL_BER_WINDOW_PROP_ID)
#define SL_SRS4_PROP_CAL_BER_WINDOW_DEF_VAL 0
#define SL_SRS4_PROP_CAL_BER_WINDOW_MIN_VAL 0
#define SL_SRS4_PROP_CAL_BER_WINDOW_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_CAL_BER_WINDOW_FMT NULL
#define SL_SRS4_PROP_CAL_BER_WINDOW_UNIT NULL

/* cal.ber.count: BER test count */
#define SL_SRS4_PROP_CAL_BER_COUNT_PROP_ID 32
#define SL_SRS4_PROP_CAL_BER_COUNT PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_CAL_GROUP_ID, SL_SRS4_PROP_CAL_BER_COUNT_PROP_ID)
#define SL_SRS4_PROP_CAL_BER_COUNT_DEF_VAL 0
#define SL_SRS4_PROP_CAL_BER_COUNT_MIN_VAL 0
#define SL_SRS4_PROP_CAL_BER_COUNT_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_CAL_BER_COUNT_FMT NULL
#define SL_SRS4_PROP_CAL_BER_COUNT_UNIT NULL

/* cal.ber.locks: BER lock count */
#define SL_SRS4_PROP_CAL_BER_LOCKS_PROP_ID 33
#define SL_SRS4_PROP_CAL_BER_LOCKS PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_CAL_GROUP_ID, SL_SRS4_PROP_CAL_BER_LOCKS_PROP_ID)
#define SL_SRS4_PROP_CAL_BER_LOCKS_DEF_VAL 0
#define SL_SRS4_PROP_CAL_BER_LOCKS_MIN_VAL 0
#define SL_SRS4_PROP_CAL_BER_LOCKS_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_CAL_BER_LOCKS_FMT NULL
#define SL_SRS4_PROP_CAL_BER_LOCKS_UNIT NULL

/* tx: Transmitter properties */
#define SL_SRS4_PROP_TX_GROUP_ID 3
#define SL_SRS4_PROP_TX_GROUP PROP_MKGROUPID(SL_SRS4_PROP_TX_GROUP_ID)

/* tx.allow.always: Always allow transmissions */
#define SL_SRS4_PROP_TX_ALLOW_ALWAYS_PROP_ID 100
#define SL_SRS4_PROP_TX_ALLOW_ALWAYS PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_ALLOW_ALWAYS_PROP_ID)
#define SL_SRS4_PROP_TX_ALLOW_ALWAYS_DEF_VAL true
#define SL_SRS4_PROP_TX_ALLOW_ALWAYS_FMT NULL
#define SL_SRS4_PROP_TX_ALLOW_ALWAYS_UNIT NULL

/* tx.allow.time: Allow transmissions time */
#define SL_SRS4_PROP_TX_ALLOW_TIME_PROP_ID 101
#define SL_SRS4_PROP_TX_ALLOW_TIME PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_ALLOW_TIME_PROP_ID)
#define SL_SRS4_PROP_TX_ALLOW_TIME_DEF_VAL 0
#define SL_SRS4_PROP_TX_ALLOW_TIME_MIN_VAL 0
#define SL_SRS4_PROP_TX_ALLOW_TIME_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TX_ALLOW_TIME_FMT NULL
#define SL_SRS4_PROP_TX_ALLOW_TIME_UNIT "s"

/* tx.freq: Transmit frequency */
#define SL_SRS4_PROP_TX_FREQ_PROP_ID 2
#define SL_SRS4_PROP_TX_FREQ PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_FREQ_PROP_ID)
#define SL_SRS4_PROP_TX_FREQ_DEF_VAL 2229500000
#define SL_SRS4_PROP_TX_FREQ_MIN_VAL 2200000000
#define SL_SRS4_PROP_TX_FREQ_MAX_VAL 2290000000
#define SL_SRS4_PROP_TX_FREQ_FMT NULL
#define SL_SRS4_PROP_TX_FREQ_UNIT "hz"

/* tx.type: Transmit modulation type (0 = BPSK, 1 = QPSK, 2 = 8PSK) */
#define SL_SRS4_PROP_TX_TYPE_PROP_ID 3
#define SL_SRS4_PROP_TX_TYPE PROP_MKID(PROP_TYPE_UINT8, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_TYPE_PROP_ID)
#define SL_SRS4_PROP_TX_TYPE_DEF_VAL 1
#define SL_SRS4_PROP_TX_TYPE_MIN_VAL 0
#define SL_SRS4_PROP_TX_TYPE_MAX_VAL 2
#define SL_SRS4_PROP_TX_TYPE_FMT NULL
#define SL_SRS4_PROP_TX_TYPE_UNIT NULL

/* tx.rate: Transmit symbol rate */
#define SL_SRS4_PROP_TX_RATE_PROP_ID 4
#define SL_SRS4_PROP_TX_RATE PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_RATE_PROP_ID)
#define SL_SRS4_PROP_TX_RATE_DEF_VAL 1000000
#define SL_SRS4_PROP_TX_RATE_MIN_VAL 100000
#define SL_SRS4_PROP_TX_RATE_MAX_VAL 5000000
#define SL_SRS4_PROP_TX_RATE_FMT NULL
#define SL_SRS4_PROP_TX_RATE_UNIT "baud"

/* tx.rolloff: RRC roll-off (0 = 0.20, 1 = 0.25, 2 = 0.35) */
#define SL_SRS4_PROP_TX_ROLLOFF_PROP_ID 5
#define SL_SRS4_PROP_TX_ROLLOFF PROP_MKID(PROP_TYPE_UINT8, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_ROLLOFF_PROP_ID)
#define SL_SRS4_PROP_TX_ROLLOFF_DEF_VAL 0
#define SL_SRS4_PROP_TX_ROLLOFF_MIN_VAL 0
#define SL_SRS4_PROP_TX_ROLLOFF_MAX_VAL 2
#define SL_SRS4_PROP_TX_ROLLOFF_FMT NULL
#define SL_SRS4_PROP_TX_ROLLOFF_UNIT NULL

/* tx.pout: Transmit power */
#define SL_SRS4_PROP_TX_POUT_PROP_ID 6
#define SL_SRS4_PROP_TX_POUT PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_POUT_PROP_ID)
#define SL_SRS4_PROP_TX_POUT_DEF_VAL 20.0
#define SL_SRS4_PROP_TX_POUT_MIN_VAL 20.0
#define SL_SRS4_PROP_TX_POUT_MAX_VAL 33.0
#define SL_SRS4_PROP_TX_POUT_FMT "%.2f"
#define SL_SRS4_PROP_TX_POUT_UNIT "dBm"

/* tx.alc.mode: Automatic Level Control mode (0 = open-loop, 1 = closed-loop) */
#define SL_SRS4_PROP_TX_ALC_MODE_PROP_ID 8
#define SL_SRS4_PROP_TX_ALC_MODE PROP_MKID(PROP_TYPE_UINT8, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_ALC_MODE_PROP_ID)
#define SL_SRS4_PROP_TX_ALC_MODE_DEF_VAL 1
#define SL_SRS4_PROP_TX_ALC_MODE_MIN_VAL 0
#define SL_SRS4_PROP_TX_ALC_MODE_MAX_VAL 1
#define SL_SRS4_PROP_TX_ALC_MODE_FMT NULL
#define SL_SRS4_PROP_TX_ALC_MODE_UNIT NULL

/* tx.rs: Enable Reed-Solomon coding */
#define SL_SRS4_PROP_TX_RS_PROP_ID 10
#define SL_SRS4_PROP_TX_RS PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_RS_PROP_ID)
#define SL_SRS4_PROP_TX_RS_DEF_VAL true
#define SL_SRS4_PROP_TX_RS_FMT NULL
#define SL_SRS4_PROP_TX_RS_UNIT NULL

/* tx.cc: Enable convolutional coding */
#define SL_SRS4_PROP_TX_CC_PROP_ID 11
#define SL_SRS4_PROP_TX_CC PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_CC_PROP_ID)
#define SL_SRS4_PROP_TX_CC_DEF_VAL true
#define SL_SRS4_PROP_TX_CC_FMT NULL
#define SL_SRS4_PROP_TX_CC_UNIT NULL

/* tx.rand: Enable randomization */
#define SL_SRS4_PROP_TX_RAND_PROP_ID 12
#define SL_SRS4_PROP_TX_RAND PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_RAND_PROP_ID)
#define SL_SRS4_PROP_TX_RAND_DEF_VAL true
#define SL_SRS4_PROP_TX_RAND_FMT NULL
#define SL_SRS4_PROP_TX_RAND_UNIT NULL

/* tx.crc: Enable CRC checksum */
#define SL_SRS4_PROP_TX_CRC_PROP_ID 13
#define SL_SRS4_PROP_TX_CRC PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_CRC_PROP_ID)
#define SL_SRS4_PROP_TX_CRC_DEF_VAL true
#define SL_SRS4_PROP_TX_CRC_FMT NULL
#define SL_SRS4_PROP_TX_CRC_UNIT NULL

/* tx.idletime: Active transmitter time after each frame */
#define SL_SRS4_PROP_TX_IDLETIME_PROP_ID 16
#define SL_SRS4_PROP_TX_IDLETIME PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_IDLETIME_PROP_ID)
#define SL_SRS4_PROP_TX_IDLETIME_DEF_VAL 30
#define SL_SRS4_PROP_TX_IDLETIME_MIN_VAL 0
#define SL_SRS4_PROP_TX_IDLETIME_MAX_VAL 600
#define SL_SRS4_PROP_TX_IDLETIME_FMT NULL
#define SL_SRS4_PROP_TX_IDLETIME_UNIT "s"

/* tx.size: Maximum payload size */
#define SL_SRS4_PROP_TX_SIZE_PROP_ID 20
#define SL_SRS4_PROP_TX_SIZE PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_SIZE_PROP_ID)
#define SL_SRS4_PROP_TX_SIZE_DEF_VAL 217
#define SL_SRS4_PROP_TX_SIZE_MIN_VAL 187
#define SL_SRS4_PROP_TX_SIZE_MAX_VAL 1024
#define SL_SRS4_PROP_TX_SIZE_FMT NULL
#define SL_SRS4_PROP_TX_SIZE_UNIT "bytes"

/* tx.id: Satellite ID/address */
#define SL_SRS4_PROP_TX_ID_PROP_ID 21
#define SL_SRS4_PROP_TX_ID PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_ID_PROP_ID)
#define SL_SRS4_PROP_TX_ID_DEF_VAL 0
#define SL_SRS4_PROP_TX_ID_MIN_VAL 0
#define SL_SRS4_PROP_TX_ID_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TX_ID_FMT NULL
#define SL_SRS4_PROP_TX_ID_UNIT NULL

/* tx.crypto.key: Encryption key */
#define SL_SRS4_PROP_TX_CRYPTO_KEY_PROP_ID 25
#define SL_SRS4_PROP_TX_CRYPTO_KEY PROP_MKID(PROP_TYPE_BINARY, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_CRYPTO_KEY_PROP_ID)
#define SL_SRS4_PROP_TX_CRYPTO_KEY_DEF_VAL "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
#define SL_SRS4_PROP_TX_CRYPTO_KEY_SIZE 32
#define SL_SRS4_PROP_TX_CRYPTO_KEY_FMT NULL
#define SL_SRS4_PROP_TX_CRYPTO_KEY_UNIT NULL

/* tx.crypto.encrypt: Encrypt frames */
#define SL_SRS4_PROP_TX_CRYPTO_ENCRYPT_PROP_ID 26
#define SL_SRS4_PROP_TX_CRYPTO_ENCRYPT PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_CRYPTO_ENCRYPT_PROP_ID)
#define SL_SRS4_PROP_TX_CRYPTO_ENCRYPT_DEF_VAL false
#define SL_SRS4_PROP_TX_CRYPTO_ENCRYPT_FMT NULL
#define SL_SRS4_PROP_TX_CRYPTO_ENCRYPT_UNIT NULL

/* tx.crypto.auth: Add authentication tag */
#define SL_SRS4_PROP_TX_CRYPTO_AUTH_PROP_ID 27
#define SL_SRS4_PROP_TX_CRYPTO_AUTH PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_CRYPTO_AUTH_PROP_ID)
#define SL_SRS4_PROP_TX_CRYPTO_AUTH_DEF_VAL false
#define SL_SRS4_PROP_TX_CRYPTO_AUTH_FMT NULL
#define SL_SRS4_PROP_TX_CRYPTO_AUTH_UNIT NULL

/* tx.pa.templimit: PA temperature limit */
#define SL_SRS4_PROP_TX_PA_TEMPLIMIT_PROP_ID 50
#define SL_SRS4_PROP_TX_PA_TEMPLIMIT PROP_MKID(PROP_TYPE_UINT8, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_PA_TEMPLIMIT_PROP_ID)
#define SL_SRS4_PROP_TX_PA_TEMPLIMIT_DEF_VAL 80
#define SL_SRS4_PROP_TX_PA_TEMPLIMIT_MIN_VAL 50
#define SL_SRS4_PROP_TX_PA_TEMPLIMIT_MAX_VAL 255
#define SL_SRS4_PROP_TX_PA_TEMPLIMIT_FMT NULL
#define SL_SRS4_PROP_TX_PA_TEMPLIMIT_UNIT NULL

/* tx.frames: Transmitted frames */
#define SL_SRS4_PROP_TX_FRAMES_PROP_ID 30
#define SL_SRS4_PROP_TX_FRAMES PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_FRAMES_PROP_ID)
#define SL_SRS4_PROP_TX_FRAMES_DEF_VAL 0
#define SL_SRS4_PROP_TX_FRAMES_MIN_VAL 0
#define SL_SRS4_PROP_TX_FRAMES_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_TX_FRAMES_FMT NULL
#define SL_SRS4_PROP_TX_FRAMES_UNIT "frames"

/* tx.pwr.fwd: Measured forward power */
#define SL_SRS4_PROP_TX_PWR_FWD_PROP_ID 35
#define SL_SRS4_PROP_TX_PWR_FWD PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_PWR_FWD_PROP_ID)
#define SL_SRS4_PROP_TX_PWR_FWD_DEF_VAL 0.0
#define SL_SRS4_PROP_TX_PWR_FWD_MIN_VAL -FLT_MAX
#define SL_SRS4_PROP_TX_PWR_FWD_MAX_VAL FLT_MAX
#define SL_SRS4_PROP_TX_PWR_FWD_FMT "%.2f"
#define SL_SRS4_PROP_TX_PWR_FWD_UNIT "dBm"

/* tx.pwr.rfl: Measured reflected power */
#define SL_SRS4_PROP_TX_PWR_RFL_PROP_ID 36
#define SL_SRS4_PROP_TX_PWR_RFL PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_TX_GROUP_ID, SL_SRS4_PROP_TX_PWR_RFL_PROP_ID)
#define SL_SRS4_PROP_TX_PWR_RFL_DEF_VAL 0.0
#define SL_SRS4_PROP_TX_PWR_RFL_MIN_VAL -FLT_MAX
#define SL_SRS4_PROP_TX_PWR_RFL_MAX_VAL FLT_MAX
#define SL_SRS4_PROP_TX_PWR_RFL_FMT "%.2f"
#define SL_SRS4_PROP_TX_PWR_RFL_UNIT "dBm"

/* rx: Receiver properties */
#define SL_SRS4_PROP_RX_GROUP_ID 4
#define SL_SRS4_PROP_RX_GROUP PROP_MKGROUPID(SL_SRS4_PROP_RX_GROUP_ID)

/* rx.freq: Receive frequency */
#define SL_SRS4_PROP_RX_FREQ_PROP_ID 2
#define SL_SRS4_PROP_RX_FREQ PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_FREQ_PROP_ID)
#define SL_SRS4_PROP_RX_FREQ_DEF_VAL 2029500000
#define SL_SRS4_PROP_RX_FREQ_MIN_VAL 2025000000
#define SL_SRS4_PROP_RX_FREQ_MAX_VAL 2110000000
#define SL_SRS4_PROP_RX_FREQ_FMT NULL
#define SL_SRS4_PROP_RX_FREQ_UNIT "hz"

/* rx.type: Receive modulation type (0 = BPSK, 1 = QPSK) */
#define SL_SRS4_PROP_RX_TYPE_PROP_ID 3
#define SL_SRS4_PROP_RX_TYPE PROP_MKID(PROP_TYPE_UINT8, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_TYPE_PROP_ID)
#define SL_SRS4_PROP_RX_TYPE_DEF_VAL 1
#define SL_SRS4_PROP_RX_TYPE_MIN_VAL 0
#define SL_SRS4_PROP_RX_TYPE_MAX_VAL 1
#define SL_SRS4_PROP_RX_TYPE_FMT NULL
#define SL_SRS4_PROP_RX_TYPE_UNIT NULL

/* rx.rate: Receive symbol rate */
#define SL_SRS4_PROP_RX_RATE_PROP_ID 4
#define SL_SRS4_PROP_RX_RATE PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_RATE_PROP_ID)
#define SL_SRS4_PROP_RX_RATE_DEF_VAL 1000000
#define SL_SRS4_PROP_RX_RATE_MIN_VAL 100000
#define SL_SRS4_PROP_RX_RATE_MAX_VAL 5000000
#define SL_SRS4_PROP_RX_RATE_FMT NULL
#define SL_SRS4_PROP_RX_RATE_UNIT "baud"

/* rx.rolloff: RRC roll-off (0 = 0.20, 1 = 0.25, 2 = 0.35) */
#define SL_SRS4_PROP_RX_ROLLOFF_PROP_ID 5
#define SL_SRS4_PROP_RX_ROLLOFF PROP_MKID(PROP_TYPE_UINT8, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_ROLLOFF_PROP_ID)
#define SL_SRS4_PROP_RX_ROLLOFF_DEF_VAL 0
#define SL_SRS4_PROP_RX_ROLLOFF_MIN_VAL 0
#define SL_SRS4_PROP_RX_ROLLOFF_MAX_VAL 2
#define SL_SRS4_PROP_RX_ROLLOFF_FMT NULL
#define SL_SRS4_PROP_RX_ROLLOFF_UNIT NULL

/* rx.afc.enable: Enable AFC */
#define SL_SRS4_PROP_RX_AFC_ENABLE_PROP_ID 40
#define SL_SRS4_PROP_RX_AFC_ENABLE PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_AFC_ENABLE_PROP_ID)
#define SL_SRS4_PROP_RX_AFC_ENABLE_DEF_VAL true
#define SL_SRS4_PROP_RX_AFC_ENABLE_FMT NULL
#define SL_SRS4_PROP_RX_AFC_ENABLE_UNIT NULL

/* rx.afc.range: AFC adjustment range */
#define SL_SRS4_PROP_RX_AFC_RANGE_PROP_ID 41
#define SL_SRS4_PROP_RX_AFC_RANGE PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_AFC_RANGE_PROP_ID)
#define SL_SRS4_PROP_RX_AFC_RANGE_DEF_VAL 15000
#define SL_SRS4_PROP_RX_AFC_RANGE_MIN_VAL 0
#define SL_SRS4_PROP_RX_AFC_RANGE_MAX_VAL 15000
#define SL_SRS4_PROP_RX_AFC_RANGE_FMT NULL
#define SL_SRS4_PROP_RX_AFC_RANGE_UNIT "Hz"

/* rx.rs: Enable Reed-Solomon coding */
#define SL_SRS4_PROP_RX_RS_PROP_ID 10
#define SL_SRS4_PROP_RX_RS PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_RS_PROP_ID)
#define SL_SRS4_PROP_RX_RS_DEF_VAL true
#define SL_SRS4_PROP_RX_RS_FMT NULL
#define SL_SRS4_PROP_RX_RS_UNIT NULL

/* rx.cc: Enable convolutional coding */
#define SL_SRS4_PROP_RX_CC_PROP_ID 11
#define SL_SRS4_PROP_RX_CC PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_CC_PROP_ID)
#define SL_SRS4_PROP_RX_CC_DEF_VAL true
#define SL_SRS4_PROP_RX_CC_FMT NULL
#define SL_SRS4_PROP_RX_CC_UNIT NULL

/* rx.rand: Enable randomization */
#define SL_SRS4_PROP_RX_RAND_PROP_ID 12
#define SL_SRS4_PROP_RX_RAND PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_RAND_PROP_ID)
#define SL_SRS4_PROP_RX_RAND_DEF_VAL true
#define SL_SRS4_PROP_RX_RAND_FMT NULL
#define SL_SRS4_PROP_RX_RAND_UNIT NULL

/* rx.crc: Enable CRC checksum */
#define SL_SRS4_PROP_RX_CRC_PROP_ID 13
#define SL_SRS4_PROP_RX_CRC PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_CRC_PROP_ID)
#define SL_SRS4_PROP_RX_CRC_DEF_VAL true
#define SL_SRS4_PROP_RX_CRC_FMT NULL
#define SL_SRS4_PROP_RX_CRC_UNIT NULL

/* rx.size: Maximum payload size */
#define SL_SRS4_PROP_RX_SIZE_PROP_ID 20
#define SL_SRS4_PROP_RX_SIZE PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_SIZE_PROP_ID)
#define SL_SRS4_PROP_RX_SIZE_DEF_VAL 217
#define SL_SRS4_PROP_RX_SIZE_MIN_VAL 187
#define SL_SRS4_PROP_RX_SIZE_MAX_VAL 1024
#define SL_SRS4_PROP_RX_SIZE_FMT NULL
#define SL_SRS4_PROP_RX_SIZE_UNIT "bytes"

/* rx.id: Satellite ID/address */
#define SL_SRS4_PROP_RX_ID_PROP_ID 21
#define SL_SRS4_PROP_RX_ID PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_ID_PROP_ID)
#define SL_SRS4_PROP_RX_ID_DEF_VAL 0
#define SL_SRS4_PROP_RX_ID_MIN_VAL 0
#define SL_SRS4_PROP_RX_ID_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_RX_ID_FMT NULL
#define SL_SRS4_PROP_RX_ID_UNIT NULL

/* rx.crypto.key: Decryption key */
#define SL_SRS4_PROP_RX_CRYPTO_KEY_PROP_ID 25
#define SL_SRS4_PROP_RX_CRYPTO_KEY PROP_MKID(PROP_TYPE_BINARY, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_CRYPTO_KEY_PROP_ID)
#define SL_SRS4_PROP_RX_CRYPTO_KEY_DEF_VAL "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
#define SL_SRS4_PROP_RX_CRYPTO_KEY_SIZE 32
#define SL_SRS4_PROP_RX_CRYPTO_KEY_FMT NULL
#define SL_SRS4_PROP_RX_CRYPTO_KEY_UNIT NULL

/* rx.crypto.decrypt: Decrypt frames */
#define SL_SRS4_PROP_RX_CRYPTO_DECRYPT_PROP_ID 26
#define SL_SRS4_PROP_RX_CRYPTO_DECRYPT PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_CRYPTO_DECRYPT_PROP_ID)
#define SL_SRS4_PROP_RX_CRYPTO_DECRYPT_DEF_VAL false
#define SL_SRS4_PROP_RX_CRYPTO_DECRYPT_FMT NULL
#define SL_SRS4_PROP_RX_CRYPTO_DECRYPT_UNIT NULL

/* rx.crypto.auth: Verify authentication tag */
#define SL_SRS4_PROP_RX_CRYPTO_AUTH_PROP_ID 27
#define SL_SRS4_PROP_RX_CRYPTO_AUTH PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_CRYPTO_AUTH_PROP_ID)
#define SL_SRS4_PROP_RX_CRYPTO_AUTH_DEF_VAL false
#define SL_SRS4_PROP_RX_CRYPTO_AUTH_FMT NULL
#define SL_SRS4_PROP_RX_CRYPTO_AUTH_UNIT NULL

/* rx.frames: Received frames */
#define SL_SRS4_PROP_RX_FRAMES_PROP_ID 30
#define SL_SRS4_PROP_RX_FRAMES PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_FRAMES_PROP_ID)
#define SL_SRS4_PROP_RX_FRAMES_DEF_VAL 0
#define SL_SRS4_PROP_RX_FRAMES_MIN_VAL 0
#define SL_SRS4_PROP_RX_FRAMES_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_RX_FRAMES_FMT NULL
#define SL_SRS4_PROP_RX_FRAMES_UNIT "frames"

/* rx.detected: Detected frames */
#define SL_SRS4_PROP_RX_DETECTED_PROP_ID 31
#define SL_SRS4_PROP_RX_DETECTED PROP_MKID(PROP_TYPE_UINT32, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_DETECTED_PROP_ID)
#define SL_SRS4_PROP_RX_DETECTED_DEF_VAL 0
#define SL_SRS4_PROP_RX_DETECTED_MIN_VAL 0
#define SL_SRS4_PROP_RX_DETECTED_MAX_VAL UINT32_MAX
#define SL_SRS4_PROP_RX_DETECTED_FMT NULL
#define SL_SRS4_PROP_RX_DETECTED_UNIT "frames"

/* rx.rssi: Measured RSSI */
#define SL_SRS4_PROP_RX_RSSI_PROP_ID 35
#define SL_SRS4_PROP_RX_RSSI PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_RSSI_PROP_ID)
#define SL_SRS4_PROP_RX_RSSI_DEF_VAL 0.0
#define SL_SRS4_PROP_RX_RSSI_MIN_VAL -FLT_MAX
#define SL_SRS4_PROP_RX_RSSI_MAX_VAL FLT_MAX
#define SL_SRS4_PROP_RX_RSSI_FMT "%.2f"
#define SL_SRS4_PROP_RX_RSSI_UNIT "dBm"

/* rx.freqerr: Estimated frequency error */
#define SL_SRS4_PROP_RX_FREQERR_PROP_ID 36
#define SL_SRS4_PROP_RX_FREQERR PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_FREQERR_PROP_ID)
#define SL_SRS4_PROP_RX_FREQERR_DEF_VAL 0.0
#define SL_SRS4_PROP_RX_FREQERR_MIN_VAL -FLT_MAX
#define SL_SRS4_PROP_RX_FREQERR_MAX_VAL FLT_MAX
#define SL_SRS4_PROP_RX_FREQERR_FMT "%.2f"
#define SL_SRS4_PROP_RX_FREQERR_UNIT "Hz"

/* rx.symerr: Estimated symbol rate error */
#define SL_SRS4_PROP_RX_SYMERR_PROP_ID 37
#define SL_SRS4_PROP_RX_SYMERR PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_SYMERR_PROP_ID)
#define SL_SRS4_PROP_RX_SYMERR_DEF_VAL 0.0
#define SL_SRS4_PROP_RX_SYMERR_MIN_VAL -FLT_MAX
#define SL_SRS4_PROP_RX_SYMERR_MAX_VAL FLT_MAX
#define SL_SRS4_PROP_RX_SYMERR_FMT "%.2f"
#define SL_SRS4_PROP_RX_SYMERR_UNIT "ppm"

/* rx.ebn0: Estimated Eb/N0 */
#define SL_SRS4_PROP_RX_EBN0_PROP_ID 38
#define SL_SRS4_PROP_RX_EBN0 PROP_MKID(PROP_TYPE_FLOAT, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_EBN0_PROP_ID)
#define SL_SRS4_PROP_RX_EBN0_DEF_VAL 0.0
#define SL_SRS4_PROP_RX_EBN0_MIN_VAL -FLT_MAX
#define SL_SRS4_PROP_RX_EBN0_MAX_VAL FLT_MAX
#define SL_SRS4_PROP_RX_EBN0_FMT "%.2f"
#define SL_SRS4_PROP_RX_EBN0_UNIT "dB"

/* rx.carrier.lock: Carrier lock */
#define SL_SRS4_PROP_RX_CARRIER_LOCK_PROP_ID 51
#define SL_SRS4_PROP_RX_CARRIER_LOCK PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_CARRIER_LOCK_PROP_ID)
#define SL_SRS4_PROP_RX_CARRIER_LOCK_DEF_VAL false
#define SL_SRS4_PROP_RX_CARRIER_LOCK_FMT NULL
#define SL_SRS4_PROP_RX_CARRIER_LOCK_UNIT NULL

/* rx.frame.lock: Frame synchronizer lock */
#define SL_SRS4_PROP_RX_FRAME_LOCK_PROP_ID 55
#define SL_SRS4_PROP_RX_FRAME_LOCK PROP_MKID(PROP_TYPE_BOOL, SL_SRS4_PROP_RX_GROUP_ID, SL_SRS4_PROP_RX_FRAME_LOCK_PROP_ID)
#define SL_SRS4_PROP_RX_FRAME_LOCK_DEF_VAL false
#define SL_SRS4_PROP_RX_FRAME_LOCK_FMT NULL
#define SL_SRS4_PROP_RX_FRAME_LOCK_UNIT NULL

/* tm: Telemetry properties */
#define SL_SRS4_PROP_TM_GROUP_ID 9
#define SL_SRS4_PROP_TM_GROUP PROP_MKGROUPID(SL_SRS4_PROP_TM_GROUP_ID)

/* tm.temp.psu: Power conversion temperature */
#define SL_SRS4_PROP_TM_TEMP_PSU_PROP_ID 20
#define SL_SRS4_PROP_TM_TEMP_PSU PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_TEMP_PSU_PROP_ID)
#define SL_SRS4_PROP_TM_TEMP_PSU_DEF_VAL 0
#define SL_SRS4_PROP_TM_TEMP_PSU_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_TEMP_PSU_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_TEMP_PSU_FMT NULL
#define SL_SRS4_PROP_TM_TEMP_PSU_UNIT "C"

/* tm.temp.mcu: MCU package temperature */
#define SL_SRS4_PROP_TM_TEMP_MCU_PROP_ID 21
#define SL_SRS4_PROP_TM_TEMP_MCU PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_TEMP_MCU_PROP_ID)
#define SL_SRS4_PROP_TM_TEMP_MCU_DEF_VAL 0
#define SL_SRS4_PROP_TM_TEMP_MCU_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_TEMP_MCU_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_TEMP_MCU_FMT NULL
#define SL_SRS4_PROP_TM_TEMP_MCU_UNIT "C"

/* tm.temp.fpga: FPGA temperature */
#define SL_SRS4_PROP_TM_TEMP_FPGA_PROP_ID 22
#define SL_SRS4_PROP_TM_TEMP_FPGA PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_TEMP_FPGA_PROP_ID)
#define SL_SRS4_PROP_TM_TEMP_FPGA_DEF_VAL 0
#define SL_SRS4_PROP_TM_TEMP_FPGA_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_TEMP_FPGA_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_TEMP_FPGA_FMT NULL
#define SL_SRS4_PROP_TM_TEMP_FPGA_UNIT "C"

/* tm.temp.xcvr: Transceiver temperature */
#define SL_SRS4_PROP_TM_TEMP_XCVR_PROP_ID 23
#define SL_SRS4_PROP_TM_TEMP_XCVR PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_TEMP_XCVR_PROP_ID)
#define SL_SRS4_PROP_TM_TEMP_XCVR_DEF_VAL 0
#define SL_SRS4_PROP_TM_TEMP_XCVR_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_TEMP_XCVR_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_TEMP_XCVR_FMT NULL
#define SL_SRS4_PROP_TM_TEMP_XCVR_UNIT "C"

/* tm.temp.lna: LNA temperature */
#define SL_SRS4_PROP_TM_TEMP_LNA_PROP_ID 24
#define SL_SRS4_PROP_TM_TEMP_LNA PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_TEMP_LNA_PROP_ID)
#define SL_SRS4_PROP_TM_TEMP_LNA_DEF_VAL 0
#define SL_SRS4_PROP_TM_TEMP_LNA_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_TEMP_LNA_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_TEMP_LNA_FMT NULL
#define SL_SRS4_PROP_TM_TEMP_LNA_UNIT "C"

/* tm.temp.pa: PA temperature */
#define SL_SRS4_PROP_TM_TEMP_PA_PROP_ID 25
#define SL_SRS4_PROP_TM_TEMP_PA PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_TEMP_PA_PROP_ID)
#define SL_SRS4_PROP_TM_TEMP_PA_DEF_VAL 0
#define SL_SRS4_PROP_TM_TEMP_PA_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_TEMP_PA_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_TEMP_PA_FMT NULL
#define SL_SRS4_PROP_TM_TEMP_PA_UNIT "C"

/* tm.volt.vin: Input voltage */
#define SL_SRS4_PROP_TM_VOLT_VIN_PROP_ID 30
#define SL_SRS4_PROP_TM_VOLT_VIN PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_VOLT_VIN_PROP_ID)
#define SL_SRS4_PROP_TM_VOLT_VIN_DEF_VAL 0
#define SL_SRS4_PROP_TM_VOLT_VIN_MIN_VAL 0
#define SL_SRS4_PROP_TM_VOLT_VIN_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_VOLT_VIN_FMT NULL
#define SL_SRS4_PROP_TM_VOLT_VIN_UNIT "mV"

/* tm.volt.3v3: 3.3 V rail voltage */
#define SL_SRS4_PROP_TM_VOLT_3V3_PROP_ID 31
#define SL_SRS4_PROP_TM_VOLT_3V3 PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_VOLT_3V3_PROP_ID)
#define SL_SRS4_PROP_TM_VOLT_3V3_DEF_VAL 0
#define SL_SRS4_PROP_TM_VOLT_3V3_MIN_VAL 0
#define SL_SRS4_PROP_TM_VOLT_3V3_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_VOLT_3V3_FMT NULL
#define SL_SRS4_PROP_TM_VOLT_3V3_UNIT "mV"

/* tm.volt.1v8: 1.8 V rail voltage */
#define SL_SRS4_PROP_TM_VOLT_1V8_PROP_ID 32
#define SL_SRS4_PROP_TM_VOLT_1V8 PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_VOLT_1V8_PROP_ID)
#define SL_SRS4_PROP_TM_VOLT_1V8_DEF_VAL 0
#define SL_SRS4_PROP_TM_VOLT_1V8_MIN_VAL 0
#define SL_SRS4_PROP_TM_VOLT_1V8_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_VOLT_1V8_FMT NULL
#define SL_SRS4_PROP_TM_VOLT_1V8_UNIT "mV"

/* tm.volt.1v0: 1.0 V rail voltage */
#define SL_SRS4_PROP_TM_VOLT_1V0_PROP_ID 33
#define SL_SRS4_PROP_TM_VOLT_1V0 PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_VOLT_1V0_PROP_ID)
#define SL_SRS4_PROP_TM_VOLT_1V0_DEF_VAL 0
#define SL_SRS4_PROP_TM_VOLT_1V0_MIN_VAL 0
#define SL_SRS4_PROP_TM_VOLT_1V0_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_VOLT_1V0_FMT NULL
#define SL_SRS4_PROP_TM_VOLT_1V0_UNIT "mV"

/* tm.volt.pa: PA voltage */
#define SL_SRS4_PROP_TM_VOLT_PA_PROP_ID 34
#define SL_SRS4_PROP_TM_VOLT_PA PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_VOLT_PA_PROP_ID)
#define SL_SRS4_PROP_TM_VOLT_PA_DEF_VAL 0
#define SL_SRS4_PROP_TM_VOLT_PA_MIN_VAL 0
#define SL_SRS4_PROP_TM_VOLT_PA_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_VOLT_PA_FMT NULL
#define SL_SRS4_PROP_TM_VOLT_PA_UNIT "mV"

/* tm.cur.vin: Input current */
#define SL_SRS4_PROP_TM_CUR_VIN_PROP_ID 40
#define SL_SRS4_PROP_TM_CUR_VIN PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_CUR_VIN_PROP_ID)
#define SL_SRS4_PROP_TM_CUR_VIN_DEF_VAL 0
#define SL_SRS4_PROP_TM_CUR_VIN_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_CUR_VIN_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_CUR_VIN_FMT NULL
#define SL_SRS4_PROP_TM_CUR_VIN_UNIT "mA"

/* tm.cur.3v3: 3.3 V rail current */
#define SL_SRS4_PROP_TM_CUR_3V3_PROP_ID 41
#define SL_SRS4_PROP_TM_CUR_3V3 PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_CUR_3V3_PROP_ID)
#define SL_SRS4_PROP_TM_CUR_3V3_DEF_VAL 0
#define SL_SRS4_PROP_TM_CUR_3V3_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_CUR_3V3_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_CUR_3V3_FMT NULL
#define SL_SRS4_PROP_TM_CUR_3V3_UNIT "mA"

/* tm.cur.1v8: 1.8 V rail current */
#define SL_SRS4_PROP_TM_CUR_1V8_PROP_ID 42
#define SL_SRS4_PROP_TM_CUR_1V8 PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_CUR_1V8_PROP_ID)
#define SL_SRS4_PROP_TM_CUR_1V8_DEF_VAL 0
#define SL_SRS4_PROP_TM_CUR_1V8_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_CUR_1V8_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_CUR_1V8_FMT NULL
#define SL_SRS4_PROP_TM_CUR_1V8_UNIT "mA"

/* tm.cur.1v0: 1.0 V rail current */
#define SL_SRS4_PROP_TM_CUR_1V0_PROP_ID 43
#define SL_SRS4_PROP_TM_CUR_1V0 PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_CUR_1V0_PROP_ID)
#define SL_SRS4_PROP_TM_CUR_1V0_DEF_VAL 0
#define SL_SRS4_PROP_TM_CUR_1V0_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_CUR_1V0_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_CUR_1V0_FMT NULL
#define SL_SRS4_PROP_TM_CUR_1V0_UNIT "mA"

/* tm.cur.pa: PA current */
#define SL_SRS4_PROP_TM_CUR_PA_PROP_ID 44
#define SL_SRS4_PROP_TM_CUR_PA PROP_MKID(PROP_TYPE_INT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_CUR_PA_PROP_ID)
#define SL_SRS4_PROP_TM_CUR_PA_DEF_VAL 0
#define SL_SRS4_PROP_TM_CUR_PA_MIN_VAL INT16_MIN
#define SL_SRS4_PROP_TM_CUR_PA_MAX_VAL INT16_MAX
#define SL_SRS4_PROP_TM_CUR_PA_FMT NULL
#define SL_SRS4_PROP_TM_CUR_PA_UNIT "mA"

/* tm.power.vin: Input power */
#define SL_SRS4_PROP_TM_POWER_VIN_PROP_ID 50
#define SL_SRS4_PROP_TM_POWER_VIN PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_POWER_VIN_PROP_ID)
#define SL_SRS4_PROP_TM_POWER_VIN_DEF_VAL 0
#define SL_SRS4_PROP_TM_POWER_VIN_MIN_VAL 0
#define SL_SRS4_PROP_TM_POWER_VIN_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_POWER_VIN_FMT NULL
#define SL_SRS4_PROP_TM_POWER_VIN_UNIT "mW"

/* tm.power.3v3: 3.3 V rail power */
#define SL_SRS4_PROP_TM_POWER_3V3_PROP_ID 51
#define SL_SRS4_PROP_TM_POWER_3V3 PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_POWER_3V3_PROP_ID)
#define SL_SRS4_PROP_TM_POWER_3V3_DEF_VAL 0
#define SL_SRS4_PROP_TM_POWER_3V3_MIN_VAL 0
#define SL_SRS4_PROP_TM_POWER_3V3_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_POWER_3V3_FMT NULL
#define SL_SRS4_PROP_TM_POWER_3V3_UNIT "mW"

/* tm.power.1v8: 1.8 V rail power */
#define SL_SRS4_PROP_TM_POWER_1V8_PROP_ID 52
#define SL_SRS4_PROP_TM_POWER_1V8 PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_POWER_1V8_PROP_ID)
#define SL_SRS4_PROP_TM_POWER_1V8_DEF_VAL 0
#define SL_SRS4_PROP_TM_POWER_1V8_MIN_VAL 0
#define SL_SRS4_PROP_TM_POWER_1V8_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_POWER_1V8_FMT NULL
#define SL_SRS4_PROP_TM_POWER_1V8_UNIT "mW"

/* tm.power.1v0: 1.0 V rail power */
#define SL_SRS4_PROP_TM_POWER_1V0_PROP_ID 53
#define SL_SRS4_PROP_TM_POWER_1V0 PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_POWER_1V0_PROP_ID)
#define SL_SRS4_PROP_TM_POWER_1V0_DEF_VAL 0
#define SL_SRS4_PROP_TM_POWER_1V0_MIN_VAL 0
#define SL_SRS4_PROP_TM_POWER_1V0_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_POWER_1V0_FMT NULL
#define SL_SRS4_PROP_TM_POWER_1V0_UNIT "mW"

/* tm.power.pa: PA power */
#define SL_SRS4_PROP_TM_POWER_PA_PROP_ID 54
#define SL_SRS4_PROP_TM_POWER_PA PROP_MKID(PROP_TYPE_UINT16, SL_SRS4_PROP_TM_GROUP_ID, SL_SRS4_PROP_TM_POWER_PA_PROP_ID)
#define SL_SRS4_PROP_TM_POWER_PA_DEF_VAL 0
#define SL_SRS4_PROP_TM_POWER_PA_MIN_VAL 0
#define SL_SRS4_PROP_TM_POWER_PA_MAX_VAL UINT16_MAX
#define SL_SRS4_PROP_TM_POWER_PA_FMT NULL
#define SL_SRS4_PROP_TM_POWER_PA_UNIT "mW"

/* Subsystem */
extern const struct prop_subsys_spec srs4_props;

#endif /* __SL_PROPS_SRS4_H__ */
