/*
 * Copyright (c) 2017-2022 Satlab A/S <satlab@satlab.com>
 * All rights reserved. Do not distribute without permission.
 *
 * Properties for Satlab SRS-4 S-band radio version 1.5.0
 *
 * Autogenerated from srs4_props.json on 2022-10-05 17:04:27
 * Please do not edit manually.
 */

#include <srs4_props.h>

/* sys: System properties */
static const struct prop_spec srs4_sys_props[] = {
	/* sys.name: String name for system */
	PROP_STRING(
		"name",
		SL_SRS4_PROP_SYS_NAME,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_NAME_DEF_VAL,
		SL_SRS4_PROP_SYS_NAME_SIZE
	),
	/* sys.serial: Serial number/ID */
	PROP_UINT32(
		"serial",
		SL_SRS4_PROP_SYS_SERIAL,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_SYS_SERIAL_DEF_VAL,
		SL_SRS4_PROP_SYS_SERIAL_MIN_VAL,
		SL_SRS4_PROP_SYS_SERIAL_MAX_VAL,
		SL_SRS4_PROP_SYS_SERIAL_FMT,
		SL_SRS4_PROP_SYS_SERIAL_UNIT
	),
	/* sys.sw.version: Running software version */
	PROP_UINT32(
		"sw.version",
		SL_SRS4_PROP_SYS_SW_VERSION,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_SYS_SW_VERSION_DEF_VAL,
		SL_SRS4_PROP_SYS_SW_VERSION_MIN_VAL,
		SL_SRS4_PROP_SYS_SW_VERSION_MAX_VAL,
		SL_SRS4_PROP_SYS_SW_VERSION_FMT,
		SL_SRS4_PROP_SYS_SW_VERSION_UNIT
	),
	/* sys.bootcount: Number of times the system was booted */
	PROP_UINT32(
		"bootcount",
		SL_SRS4_PROP_SYS_BOOTCOUNT,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_SYS_BOOTCOUNT_DEF_VAL,
		SL_SRS4_PROP_SYS_BOOTCOUNT_MIN_VAL,
		SL_SRS4_PROP_SYS_BOOTCOUNT_MAX_VAL,
		SL_SRS4_PROP_SYS_BOOTCOUNT_FMT,
		SL_SRS4_PROP_SYS_BOOTCOUNT_UNIT
	),
	/* sys.reboot: Reboot timer */
	PROP_UINT16(
		"reboot",
		SL_SRS4_PROP_SYS_REBOOT,
		PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_SYS_REBOOT_DEF_VAL,
		SL_SRS4_PROP_SYS_REBOOT_MIN_VAL,
		SL_SRS4_PROP_SYS_REBOOT_MAX_VAL,
		SL_SRS4_PROP_SYS_REBOOT_FMT,
		SL_SRS4_PROP_SYS_REBOOT_UNIT
	),
	/* sys.gwdt.init: GWDT timer reset value */
	PROP_UINT32(
		"gwdt.init",
		SL_SRS4_PROP_SYS_GWDT_INIT,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_GWDT_INIT_DEF_VAL,
		SL_SRS4_PROP_SYS_GWDT_INIT_MIN_VAL,
		SL_SRS4_PROP_SYS_GWDT_INIT_MAX_VAL,
		SL_SRS4_PROP_SYS_GWDT_INIT_FMT,
		SL_SRS4_PROP_SYS_GWDT_INIT_UNIT
	),
	/* sys.gwdt.counter: GWDT current counter value */
	PROP_UINT32(
		"gwdt.counter",
		SL_SRS4_PROP_SYS_GWDT_COUNTER,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_SYS_GWDT_COUNTER_DEF_VAL,
		SL_SRS4_PROP_SYS_GWDT_COUNTER_MIN_VAL,
		SL_SRS4_PROP_SYS_GWDT_COUNTER_MAX_VAL,
		SL_SRS4_PROP_SYS_GWDT_COUNTER_FMT,
		SL_SRS4_PROP_SYS_GWDT_COUNTER_UNIT
	),
	/* sys.gwdt.reset: GWDT reset trigger */
	PROP_UINT32(
		"gwdt.reset",
		SL_SRS4_PROP_SYS_GWDT_RESET,
		PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_SYS_GWDT_RESET_DEF_VAL,
		SL_SRS4_PROP_SYS_GWDT_RESET_MIN_VAL,
		SL_SRS4_PROP_SYS_GWDT_RESET_MAX_VAL,
		SL_SRS4_PROP_SYS_GWDT_RESET_FMT,
		SL_SRS4_PROP_SYS_GWDT_RESET_UNIT
	),
	/* sys.csp.address: CSP address of the device */
	PROP_UINT8(
		"csp.address",
		SL_SRS4_PROP_SYS_CSP_ADDRESS,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_CSP_ADDRESS_DEF_VAL,
		SL_SRS4_PROP_SYS_CSP_ADDRESS_MIN_VAL,
		SL_SRS4_PROP_SYS_CSP_ADDRESS_MAX_VAL,
		SL_SRS4_PROP_SYS_CSP_ADDRESS_FMT,
		SL_SRS4_PROP_SYS_CSP_ADDRESS_UNIT
	),
	/* sys.csp.routes: CSP routing table in CIDR notation */
	PROP_STRING(
		"csp.routes",
		SL_SRS4_PROP_SYS_CSP_ROUTES,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_CSP_ROUTES_DEF_VAL,
		SL_SRS4_PROP_SYS_CSP_ROUTES_SIZE
	),
	/* sys.can.rate: CAN-bus bitrate */
	PROP_UINT32(
		"can.rate",
		SL_SRS4_PROP_SYS_CAN_RATE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_CAN_RATE_DEF_VAL,
		SL_SRS4_PROP_SYS_CAN_RATE_MIN_VAL,
		SL_SRS4_PROP_SYS_CAN_RATE_MAX_VAL,
		SL_SRS4_PROP_SYS_CAN_RATE_FMT,
		SL_SRS4_PROP_SYS_CAN_RATE_UNIT
	),
	/* sys.can.promisc: Accept all CSP CAN-frames */
	PROP_BOOL(
		"can.promisc",
		SL_SRS4_PROP_SYS_CAN_PROMISC,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_CAN_PROMISC_DEF_VAL
	),
	/* sys.uart.rate: UART baudrate */
	PROP_UINT32(
		"uart.rate",
		SL_SRS4_PROP_SYS_UART_RATE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_UART_RATE_DEF_VAL,
		SL_SRS4_PROP_SYS_UART_RATE_MIN_VAL,
		SL_SRS4_PROP_SYS_UART_RATE_MAX_VAL,
		SL_SRS4_PROP_SYS_UART_RATE_FMT,
		SL_SRS4_PROP_SYS_UART_RATE_UNIT
	),
	/* sys.uart.multidrop: UART multidrop mode */
	PROP_BOOL(
		"uart.multidrop",
		SL_SRS4_PROP_SYS_UART_MULTIDROP,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_UART_MULTIDROP_DEF_VAL
	),
	/* sys.net.enable: IP stack enable */
	PROP_BOOL(
		"net.enable",
		SL_SRS4_PROP_SYS_NET_ENABLE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_NET_ENABLE_DEF_VAL
	),
	/* sys.net.en.ip: Ethernet IP address */
	PROP_STRING(
		"net.en.ip",
		SL_SRS4_PROP_SYS_NET_EN_IP,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_NET_EN_IP_DEF_VAL,
		SL_SRS4_PROP_SYS_NET_EN_IP_SIZE
	),
	/* sys.net.en.prefix: Ethernet network prefix bits */
	PROP_UINT8(
		"net.en.prefix",
		SL_SRS4_PROP_SYS_NET_EN_PREFIX,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_NET_EN_PREFIX_DEF_VAL,
		SL_SRS4_PROP_SYS_NET_EN_PREFIX_MIN_VAL,
		SL_SRS4_PROP_SYS_NET_EN_PREFIX_MAX_VAL,
		SL_SRS4_PROP_SYS_NET_EN_PREFIX_FMT,
		SL_SRS4_PROP_SYS_NET_EN_PREFIX_UNIT
	),
	/* sys.net.en.gw: Ethernet gateway IP address */
	PROP_STRING(
		"net.en.gw",
		SL_SRS4_PROP_SYS_NET_EN_GW,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_NET_EN_GW_DEF_VAL,
		SL_SRS4_PROP_SYS_NET_EN_GW_SIZE
	),
	/* sys.net.rf.ip: Spacelink IP address */
	PROP_STRING(
		"net.rf.ip",
		SL_SRS4_PROP_SYS_NET_RF_IP,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_NET_RF_IP_DEF_VAL,
		SL_SRS4_PROP_SYS_NET_RF_IP_SIZE
	),
	/* sys.net.rf.prefix: Spacelink network prefix bits */
	PROP_UINT8(
		"net.rf.prefix",
		SL_SRS4_PROP_SYS_NET_RF_PREFIX,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_NET_RF_PREFIX_DEF_VAL,
		SL_SRS4_PROP_SYS_NET_RF_PREFIX_MIN_VAL,
		SL_SRS4_PROP_SYS_NET_RF_PREFIX_MAX_VAL,
		SL_SRS4_PROP_SYS_NET_RF_PREFIX_FMT,
		SL_SRS4_PROP_SYS_NET_RF_PREFIX_UNIT
	),
	/* sys.net.rf.gw: Spacelink gateway IP address */
	PROP_STRING(
		"net.rf.gw",
		SL_SRS4_PROP_SYS_NET_RF_GW,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_SYS_NET_RF_GW_DEF_VAL,
		SL_SRS4_PROP_SYS_NET_RF_GW_SIZE
	),
};

/* cal: Calibration properties */
static const struct prop_spec srs4_cal_props[] = {
	/* cal.ps.gain: Power sensor gain */
	PROP_FLOAT(
		"ps.gain",
		SL_SRS4_PROP_CAL_PS_GAIN,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_CAL_PS_GAIN_DEF_VAL,
		SL_SRS4_PROP_CAL_PS_GAIN_MIN_VAL,
		SL_SRS4_PROP_CAL_PS_GAIN_MAX_VAL,
		SL_SRS4_PROP_CAL_PS_GAIN_FMT,
		SL_SRS4_PROP_CAL_PS_GAIN_UNIT
	),
	/* cal.ps.intercept: Power sensor intercept */
	PROP_FLOAT(
		"ps.intercept",
		SL_SRS4_PROP_CAL_PS_INTERCEPT,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_CAL_PS_INTERCEPT_DEF_VAL,
		SL_SRS4_PROP_CAL_PS_INTERCEPT_MIN_VAL,
		SL_SRS4_PROP_CAL_PS_INTERCEPT_MAX_VAL,
		SL_SRS4_PROP_CAL_PS_INTERCEPT_FMT,
		SL_SRS4_PROP_CAL_PS_INTERCEPT_UNIT
	),
	/* cal.vctcxo: VCTCXO adjust */
	PROP_UINT16(
		"vctcxo",
		SL_SRS4_PROP_CAL_VCTCXO,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_CAL_VCTCXO_DEF_VAL,
		SL_SRS4_PROP_CAL_VCTCXO_MIN_VAL,
		SL_SRS4_PROP_CAL_VCTCXO_MAX_VAL,
		SL_SRS4_PROP_CAL_VCTCXO_FMT,
		SL_SRS4_PROP_CAL_VCTCXO_UNIT
	),
	/* cal.pwr.set: Current pout setpoint */
	PROP_FLOAT(
		"pwr.set",
		SL_SRS4_PROP_CAL_PWR_SET,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_CAL_PWR_SET_DEF_VAL,
		SL_SRS4_PROP_CAL_PWR_SET_MIN_VAL,
		SL_SRS4_PROP_CAL_PWR_SET_MAX_VAL,
		SL_SRS4_PROP_CAL_PWR_SET_FMT,
		SL_SRS4_PROP_CAL_PWR_SET_UNIT
	),
	/* cal.ber.enable: Enable BER test */
	PROP_BOOL(
		"ber.enable",
		SL_SRS4_PROP_CAL_BER_ENABLE,
		PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_CAL_BER_ENABLE_DEF_VAL
	),
	/* cal.ber.window: BER window size */
	PROP_UINT32(
		"ber.window",
		SL_SRS4_PROP_CAL_BER_WINDOW,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_CAL_BER_WINDOW_DEF_VAL,
		SL_SRS4_PROP_CAL_BER_WINDOW_MIN_VAL,
		SL_SRS4_PROP_CAL_BER_WINDOW_MAX_VAL,
		SL_SRS4_PROP_CAL_BER_WINDOW_FMT,
		SL_SRS4_PROP_CAL_BER_WINDOW_UNIT
	),
	/* cal.ber.count: BER test count */
	PROP_UINT32(
		"ber.count",
		SL_SRS4_PROP_CAL_BER_COUNT,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_CAL_BER_COUNT_DEF_VAL,
		SL_SRS4_PROP_CAL_BER_COUNT_MIN_VAL,
		SL_SRS4_PROP_CAL_BER_COUNT_MAX_VAL,
		SL_SRS4_PROP_CAL_BER_COUNT_FMT,
		SL_SRS4_PROP_CAL_BER_COUNT_UNIT
	),
	/* cal.ber.locks: BER lock count */
	PROP_UINT32(
		"ber.locks",
		SL_SRS4_PROP_CAL_BER_LOCKS,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_CAL_BER_LOCKS_DEF_VAL,
		SL_SRS4_PROP_CAL_BER_LOCKS_MIN_VAL,
		SL_SRS4_PROP_CAL_BER_LOCKS_MAX_VAL,
		SL_SRS4_PROP_CAL_BER_LOCKS_FMT,
		SL_SRS4_PROP_CAL_BER_LOCKS_UNIT
	),
};

/* tx: Transmitter properties */
static const struct prop_spec srs4_tx_props[] = {
	/* tx.allow.always: Always allow transmissions */
	PROP_BOOL(
		"allow.always",
		SL_SRS4_PROP_TX_ALLOW_ALWAYS,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_ALLOW_ALWAYS_DEF_VAL
	),
	/* tx.allow.time: Allow transmissions time */
	PROP_UINT16(
		"allow.time",
		SL_SRS4_PROP_TX_ALLOW_TIME,
		PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_TX_ALLOW_TIME_DEF_VAL,
		SL_SRS4_PROP_TX_ALLOW_TIME_MIN_VAL,
		SL_SRS4_PROP_TX_ALLOW_TIME_MAX_VAL,
		SL_SRS4_PROP_TX_ALLOW_TIME_FMT,
		SL_SRS4_PROP_TX_ALLOW_TIME_UNIT
	),
	/* tx.freq: Transmit frequency */
	PROP_UINT32(
		"freq",
		SL_SRS4_PROP_TX_FREQ,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_FREQ_DEF_VAL,
		SL_SRS4_PROP_TX_FREQ_MIN_VAL,
		SL_SRS4_PROP_TX_FREQ_MAX_VAL,
		SL_SRS4_PROP_TX_FREQ_FMT,
		SL_SRS4_PROP_TX_FREQ_UNIT
	),
	/* tx.type: Transmit modulation type (0 = BPSK, 1 = QPSK, 2 = 8PSK) */
	PROP_UINT8(
		"type",
		SL_SRS4_PROP_TX_TYPE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_TYPE_DEF_VAL,
		SL_SRS4_PROP_TX_TYPE_MIN_VAL,
		SL_SRS4_PROP_TX_TYPE_MAX_VAL,
		SL_SRS4_PROP_TX_TYPE_FMT,
		SL_SRS4_PROP_TX_TYPE_UNIT
	),
	/* tx.rate: Transmit symbol rate */
	PROP_UINT32(
		"rate",
		SL_SRS4_PROP_TX_RATE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_RATE_DEF_VAL,
		SL_SRS4_PROP_TX_RATE_MIN_VAL,
		SL_SRS4_PROP_TX_RATE_MAX_VAL,
		SL_SRS4_PROP_TX_RATE_FMT,
		SL_SRS4_PROP_TX_RATE_UNIT
	),
	/* tx.rolloff: RRC roll-off (0 = 0.20, 1 = 0.25, 2 = 0.35) */
	PROP_UINT8(
		"rolloff",
		SL_SRS4_PROP_TX_ROLLOFF,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_ROLLOFF_DEF_VAL,
		SL_SRS4_PROP_TX_ROLLOFF_MIN_VAL,
		SL_SRS4_PROP_TX_ROLLOFF_MAX_VAL,
		SL_SRS4_PROP_TX_ROLLOFF_FMT,
		SL_SRS4_PROP_TX_ROLLOFF_UNIT
	),
	/* tx.pout: Transmit power */
	PROP_FLOAT(
		"pout",
		SL_SRS4_PROP_TX_POUT,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_POUT_DEF_VAL,
		SL_SRS4_PROP_TX_POUT_MIN_VAL,
		SL_SRS4_PROP_TX_POUT_MAX_VAL,
		SL_SRS4_PROP_TX_POUT_FMT,
		SL_SRS4_PROP_TX_POUT_UNIT
	),
	/* tx.alc.mode: Automatic Level Control mode (0 = open-loop, 1 = closed-loop) */
	PROP_UINT8(
		"alc.mode",
		SL_SRS4_PROP_TX_ALC_MODE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_ALC_MODE_DEF_VAL,
		SL_SRS4_PROP_TX_ALC_MODE_MIN_VAL,
		SL_SRS4_PROP_TX_ALC_MODE_MAX_VAL,
		SL_SRS4_PROP_TX_ALC_MODE_FMT,
		SL_SRS4_PROP_TX_ALC_MODE_UNIT
	),
	/* tx.rs: Enable Reed-Solomon coding */
	PROP_BOOL(
		"rs",
		SL_SRS4_PROP_TX_RS,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_RS_DEF_VAL
	),
	/* tx.cc: Enable convolutional coding */
	PROP_BOOL(
		"cc",
		SL_SRS4_PROP_TX_CC,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_CC_DEF_VAL
	),
	/* tx.rand: Enable randomization */
	PROP_BOOL(
		"rand",
		SL_SRS4_PROP_TX_RAND,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_RAND_DEF_VAL
	),
	/* tx.crc: Enable CRC checksum */
	PROP_BOOL(
		"crc",
		SL_SRS4_PROP_TX_CRC,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_CRC_DEF_VAL
	),
	/* tx.idletime: Active transmitter time after each frame */
	PROP_UINT16(
		"idletime",
		SL_SRS4_PROP_TX_IDLETIME,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_IDLETIME_DEF_VAL,
		SL_SRS4_PROP_TX_IDLETIME_MIN_VAL,
		SL_SRS4_PROP_TX_IDLETIME_MAX_VAL,
		SL_SRS4_PROP_TX_IDLETIME_FMT,
		SL_SRS4_PROP_TX_IDLETIME_UNIT
	),
	/* tx.size: Maximum payload size */
	PROP_UINT16(
		"size",
		SL_SRS4_PROP_TX_SIZE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_SIZE_DEF_VAL,
		SL_SRS4_PROP_TX_SIZE_MIN_VAL,
		SL_SRS4_PROP_TX_SIZE_MAX_VAL,
		SL_SRS4_PROP_TX_SIZE_FMT,
		SL_SRS4_PROP_TX_SIZE_UNIT
	),
	/* tx.id: Satellite ID/address */
	PROP_UINT16(
		"id",
		SL_SRS4_PROP_TX_ID,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_ID_DEF_VAL,
		SL_SRS4_PROP_TX_ID_MIN_VAL,
		SL_SRS4_PROP_TX_ID_MAX_VAL,
		SL_SRS4_PROP_TX_ID_FMT,
		SL_SRS4_PROP_TX_ID_UNIT
	),
	/* tx.crypto.key: Encryption key */
	PROP_BINARY(
		"crypto.key",
		SL_SRS4_PROP_TX_CRYPTO_KEY,
		PROP_FLAG_SECRET,
		SL_SRS4_PROP_TX_CRYPTO_KEY_DEF_VAL,
		SL_SRS4_PROP_TX_CRYPTO_KEY_SIZE
	),
	/* tx.crypto.encrypt: Encrypt frames */
	PROP_BOOL(
		"crypto.encrypt",
		SL_SRS4_PROP_TX_CRYPTO_ENCRYPT,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_CRYPTO_ENCRYPT_DEF_VAL
	),
	/* tx.crypto.auth: Add authentication tag */
	PROP_BOOL(
		"crypto.auth",
		SL_SRS4_PROP_TX_CRYPTO_AUTH,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_CRYPTO_AUTH_DEF_VAL
	),
	/* tx.pa.templimit: PA temperature limit */
	PROP_UINT8(
		"pa.templimit",
		SL_SRS4_PROP_TX_PA_TEMPLIMIT,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_TX_PA_TEMPLIMIT_DEF_VAL,
		SL_SRS4_PROP_TX_PA_TEMPLIMIT_MIN_VAL,
		SL_SRS4_PROP_TX_PA_TEMPLIMIT_MAX_VAL,
		SL_SRS4_PROP_TX_PA_TEMPLIMIT_FMT,
		SL_SRS4_PROP_TX_PA_TEMPLIMIT_UNIT
	),
	/* tx.frames: Transmitted frames */
	PROP_UINT32(
		"frames",
		SL_SRS4_PROP_TX_FRAMES,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_TX_FRAMES_DEF_VAL,
		SL_SRS4_PROP_TX_FRAMES_MIN_VAL,
		SL_SRS4_PROP_TX_FRAMES_MAX_VAL,
		SL_SRS4_PROP_TX_FRAMES_FMT,
		SL_SRS4_PROP_TX_FRAMES_UNIT
	),
	/* tx.pwr.fwd: Measured forward power */
	PROP_FLOAT(
		"pwr.fwd",
		SL_SRS4_PROP_TX_PWR_FWD,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_TX_PWR_FWD_DEF_VAL,
		SL_SRS4_PROP_TX_PWR_FWD_MIN_VAL,
		SL_SRS4_PROP_TX_PWR_FWD_MAX_VAL,
		SL_SRS4_PROP_TX_PWR_FWD_FMT,
		SL_SRS4_PROP_TX_PWR_FWD_UNIT
	),
	/* tx.pwr.rfl: Measured reflected power */
	PROP_FLOAT(
		"pwr.rfl",
		SL_SRS4_PROP_TX_PWR_RFL,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_TX_PWR_RFL_DEF_VAL,
		SL_SRS4_PROP_TX_PWR_RFL_MIN_VAL,
		SL_SRS4_PROP_TX_PWR_RFL_MAX_VAL,
		SL_SRS4_PROP_TX_PWR_RFL_FMT,
		SL_SRS4_PROP_TX_PWR_RFL_UNIT
	),
};

/* rx: Receiver properties */
static const struct prop_spec srs4_rx_props[] = {
	/* rx.freq: Receive frequency */
	PROP_UINT32(
		"freq",
		SL_SRS4_PROP_RX_FREQ,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_FREQ_DEF_VAL,
		SL_SRS4_PROP_RX_FREQ_MIN_VAL,
		SL_SRS4_PROP_RX_FREQ_MAX_VAL,
		SL_SRS4_PROP_RX_FREQ_FMT,
		SL_SRS4_PROP_RX_FREQ_UNIT
	),
	/* rx.type: Receive modulation type (0 = BPSK, 1 = QPSK) */
	PROP_UINT8(
		"type",
		SL_SRS4_PROP_RX_TYPE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_TYPE_DEF_VAL,
		SL_SRS4_PROP_RX_TYPE_MIN_VAL,
		SL_SRS4_PROP_RX_TYPE_MAX_VAL,
		SL_SRS4_PROP_RX_TYPE_FMT,
		SL_SRS4_PROP_RX_TYPE_UNIT
	),
	/* rx.rate: Receive symbol rate */
	PROP_UINT32(
		"rate",
		SL_SRS4_PROP_RX_RATE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_RATE_DEF_VAL,
		SL_SRS4_PROP_RX_RATE_MIN_VAL,
		SL_SRS4_PROP_RX_RATE_MAX_VAL,
		SL_SRS4_PROP_RX_RATE_FMT,
		SL_SRS4_PROP_RX_RATE_UNIT
	),
	/* rx.rolloff: RRC roll-off (0 = 0.20, 1 = 0.25, 2 = 0.35) */
	PROP_UINT8(
		"rolloff",
		SL_SRS4_PROP_RX_ROLLOFF,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_ROLLOFF_DEF_VAL,
		SL_SRS4_PROP_RX_ROLLOFF_MIN_VAL,
		SL_SRS4_PROP_RX_ROLLOFF_MAX_VAL,
		SL_SRS4_PROP_RX_ROLLOFF_FMT,
		SL_SRS4_PROP_RX_ROLLOFF_UNIT
	),
	/* rx.afc.enable: Enable AFC */
	PROP_BOOL(
		"afc.enable",
		SL_SRS4_PROP_RX_AFC_ENABLE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_AFC_ENABLE_DEF_VAL
	),
	/* rx.afc.range: AFC adjustment range */
	PROP_UINT32(
		"afc.range",
		SL_SRS4_PROP_RX_AFC_RANGE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_AFC_RANGE_DEF_VAL,
		SL_SRS4_PROP_RX_AFC_RANGE_MIN_VAL,
		SL_SRS4_PROP_RX_AFC_RANGE_MAX_VAL,
		SL_SRS4_PROP_RX_AFC_RANGE_FMT,
		SL_SRS4_PROP_RX_AFC_RANGE_UNIT
	),
	/* rx.rs: Enable Reed-Solomon coding */
	PROP_BOOL(
		"rs",
		SL_SRS4_PROP_RX_RS,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_RS_DEF_VAL
	),
	/* rx.cc: Enable convolutional coding */
	PROP_BOOL(
		"cc",
		SL_SRS4_PROP_RX_CC,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_CC_DEF_VAL
	),
	/* rx.rand: Enable randomization */
	PROP_BOOL(
		"rand",
		SL_SRS4_PROP_RX_RAND,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_RAND_DEF_VAL
	),
	/* rx.crc: Enable CRC checksum */
	PROP_BOOL(
		"crc",
		SL_SRS4_PROP_RX_CRC,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_CRC_DEF_VAL
	),
	/* rx.size: Maximum payload size */
	PROP_UINT16(
		"size",
		SL_SRS4_PROP_RX_SIZE,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_SIZE_DEF_VAL,
		SL_SRS4_PROP_RX_SIZE_MIN_VAL,
		SL_SRS4_PROP_RX_SIZE_MAX_VAL,
		SL_SRS4_PROP_RX_SIZE_FMT,
		SL_SRS4_PROP_RX_SIZE_UNIT
	),
	/* rx.id: Satellite ID/address */
	PROP_UINT16(
		"id",
		SL_SRS4_PROP_RX_ID,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_ID_DEF_VAL,
		SL_SRS4_PROP_RX_ID_MIN_VAL,
		SL_SRS4_PROP_RX_ID_MAX_VAL,
		SL_SRS4_PROP_RX_ID_FMT,
		SL_SRS4_PROP_RX_ID_UNIT
	),
	/* rx.crypto.key: Decryption key */
	PROP_BINARY(
		"crypto.key",
		SL_SRS4_PROP_RX_CRYPTO_KEY,
		PROP_FLAG_SECRET,
		SL_SRS4_PROP_RX_CRYPTO_KEY_DEF_VAL,
		SL_SRS4_PROP_RX_CRYPTO_KEY_SIZE
	),
	/* rx.crypto.decrypt: Decrypt frames */
	PROP_BOOL(
		"crypto.decrypt",
		SL_SRS4_PROP_RX_CRYPTO_DECRYPT,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_CRYPTO_DECRYPT_DEF_VAL
	),
	/* rx.crypto.auth: Verify authentication tag */
	PROP_BOOL(
		"crypto.auth",
		SL_SRS4_PROP_RX_CRYPTO_AUTH,
		PROP_FLAG_NONE,
		SL_SRS4_PROP_RX_CRYPTO_AUTH_DEF_VAL
	),
	/* rx.frames: Received frames */
	PROP_UINT32(
		"frames",
		SL_SRS4_PROP_RX_FRAMES,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_RX_FRAMES_DEF_VAL,
		SL_SRS4_PROP_RX_FRAMES_MIN_VAL,
		SL_SRS4_PROP_RX_FRAMES_MAX_VAL,
		SL_SRS4_PROP_RX_FRAMES_FMT,
		SL_SRS4_PROP_RX_FRAMES_UNIT
	),
	/* rx.detected: Detected frames */
	PROP_UINT32(
		"detected",
		SL_SRS4_PROP_RX_DETECTED,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_RX_DETECTED_DEF_VAL,
		SL_SRS4_PROP_RX_DETECTED_MIN_VAL,
		SL_SRS4_PROP_RX_DETECTED_MAX_VAL,
		SL_SRS4_PROP_RX_DETECTED_FMT,
		SL_SRS4_PROP_RX_DETECTED_UNIT
	),
	/* rx.rssi: Measured RSSI */
	PROP_FLOAT(
		"rssi",
		SL_SRS4_PROP_RX_RSSI,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_RX_RSSI_DEF_VAL,
		SL_SRS4_PROP_RX_RSSI_MIN_VAL,
		SL_SRS4_PROP_RX_RSSI_MAX_VAL,
		SL_SRS4_PROP_RX_RSSI_FMT,
		SL_SRS4_PROP_RX_RSSI_UNIT
	),
	/* rx.freqerr: Estimated frequency error */
	PROP_FLOAT(
		"freqerr",
		SL_SRS4_PROP_RX_FREQERR,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_RX_FREQERR_DEF_VAL,
		SL_SRS4_PROP_RX_FREQERR_MIN_VAL,
		SL_SRS4_PROP_RX_FREQERR_MAX_VAL,
		SL_SRS4_PROP_RX_FREQERR_FMT,
		SL_SRS4_PROP_RX_FREQERR_UNIT
	),
	/* rx.symerr: Estimated symbol rate error */
	PROP_FLOAT(
		"symerr",
		SL_SRS4_PROP_RX_SYMERR,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_RX_SYMERR_DEF_VAL,
		SL_SRS4_PROP_RX_SYMERR_MIN_VAL,
		SL_SRS4_PROP_RX_SYMERR_MAX_VAL,
		SL_SRS4_PROP_RX_SYMERR_FMT,
		SL_SRS4_PROP_RX_SYMERR_UNIT
	),
	/* rx.ebn0: Estimated Eb/N0 */
	PROP_FLOAT(
		"ebn0",
		SL_SRS4_PROP_RX_EBN0,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_RX_EBN0_DEF_VAL,
		SL_SRS4_PROP_RX_EBN0_MIN_VAL,
		SL_SRS4_PROP_RX_EBN0_MAX_VAL,
		SL_SRS4_PROP_RX_EBN0_FMT,
		SL_SRS4_PROP_RX_EBN0_UNIT
	),
	/* rx.carrier.lock: Carrier lock */
	PROP_BOOL(
		"carrier.lock",
		SL_SRS4_PROP_RX_CARRIER_LOCK,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_RX_CARRIER_LOCK_DEF_VAL
	),
	/* rx.frame.lock: Frame synchronizer lock */
	PROP_BOOL(
		"frame.lock",
		SL_SRS4_PROP_RX_FRAME_LOCK,
		PROP_FLAG_READONLY | PROP_FLAG_NOSTORE,
		SL_SRS4_PROP_RX_FRAME_LOCK_DEF_VAL
	),
};

/* tm: Telemetry properties */
static const struct prop_spec srs4_tm_props[] = {
	/* tm.temp.psu: Power conversion temperature */
	PROP_INT16(
		"temp.psu",
		SL_SRS4_PROP_TM_TEMP_PSU,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_TEMP_PSU_DEF_VAL,
		SL_SRS4_PROP_TM_TEMP_PSU_MIN_VAL,
		SL_SRS4_PROP_TM_TEMP_PSU_MAX_VAL,
		SL_SRS4_PROP_TM_TEMP_PSU_FMT,
		SL_SRS4_PROP_TM_TEMP_PSU_UNIT
	),
	/* tm.temp.mcu: MCU package temperature */
	PROP_INT16(
		"temp.mcu",
		SL_SRS4_PROP_TM_TEMP_MCU,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_TEMP_MCU_DEF_VAL,
		SL_SRS4_PROP_TM_TEMP_MCU_MIN_VAL,
		SL_SRS4_PROP_TM_TEMP_MCU_MAX_VAL,
		SL_SRS4_PROP_TM_TEMP_MCU_FMT,
		SL_SRS4_PROP_TM_TEMP_MCU_UNIT
	),
	/* tm.temp.fpga: FPGA temperature */
	PROP_INT16(
		"temp.fpga",
		SL_SRS4_PROP_TM_TEMP_FPGA,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_TEMP_FPGA_DEF_VAL,
		SL_SRS4_PROP_TM_TEMP_FPGA_MIN_VAL,
		SL_SRS4_PROP_TM_TEMP_FPGA_MAX_VAL,
		SL_SRS4_PROP_TM_TEMP_FPGA_FMT,
		SL_SRS4_PROP_TM_TEMP_FPGA_UNIT
	),
	/* tm.temp.xcvr: Transceiver temperature */
	PROP_INT16(
		"temp.xcvr",
		SL_SRS4_PROP_TM_TEMP_XCVR,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_TEMP_XCVR_DEF_VAL,
		SL_SRS4_PROP_TM_TEMP_XCVR_MIN_VAL,
		SL_SRS4_PROP_TM_TEMP_XCVR_MAX_VAL,
		SL_SRS4_PROP_TM_TEMP_XCVR_FMT,
		SL_SRS4_PROP_TM_TEMP_XCVR_UNIT
	),
	/* tm.temp.lna: LNA temperature */
	PROP_INT16(
		"temp.lna",
		SL_SRS4_PROP_TM_TEMP_LNA,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_TEMP_LNA_DEF_VAL,
		SL_SRS4_PROP_TM_TEMP_LNA_MIN_VAL,
		SL_SRS4_PROP_TM_TEMP_LNA_MAX_VAL,
		SL_SRS4_PROP_TM_TEMP_LNA_FMT,
		SL_SRS4_PROP_TM_TEMP_LNA_UNIT
	),
	/* tm.temp.pa: PA temperature */
	PROP_INT16(
		"temp.pa",
		SL_SRS4_PROP_TM_TEMP_PA,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_TEMP_PA_DEF_VAL,
		SL_SRS4_PROP_TM_TEMP_PA_MIN_VAL,
		SL_SRS4_PROP_TM_TEMP_PA_MAX_VAL,
		SL_SRS4_PROP_TM_TEMP_PA_FMT,
		SL_SRS4_PROP_TM_TEMP_PA_UNIT
	),
	/* tm.volt.vin: Input voltage */
	PROP_UINT16(
		"volt.vin",
		SL_SRS4_PROP_TM_VOLT_VIN,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_VOLT_VIN_DEF_VAL,
		SL_SRS4_PROP_TM_VOLT_VIN_MIN_VAL,
		SL_SRS4_PROP_TM_VOLT_VIN_MAX_VAL,
		SL_SRS4_PROP_TM_VOLT_VIN_FMT,
		SL_SRS4_PROP_TM_VOLT_VIN_UNIT
	),
	/* tm.volt.3v3: 3.3 V rail voltage */
	PROP_UINT16(
		"volt.3v3",
		SL_SRS4_PROP_TM_VOLT_3V3,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_VOLT_3V3_DEF_VAL,
		SL_SRS4_PROP_TM_VOLT_3V3_MIN_VAL,
		SL_SRS4_PROP_TM_VOLT_3V3_MAX_VAL,
		SL_SRS4_PROP_TM_VOLT_3V3_FMT,
		SL_SRS4_PROP_TM_VOLT_3V3_UNIT
	),
	/* tm.volt.1v8: 1.8 V rail voltage */
	PROP_UINT16(
		"volt.1v8",
		SL_SRS4_PROP_TM_VOLT_1V8,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_VOLT_1V8_DEF_VAL,
		SL_SRS4_PROP_TM_VOLT_1V8_MIN_VAL,
		SL_SRS4_PROP_TM_VOLT_1V8_MAX_VAL,
		SL_SRS4_PROP_TM_VOLT_1V8_FMT,
		SL_SRS4_PROP_TM_VOLT_1V8_UNIT
	),
	/* tm.volt.1v0: 1.0 V rail voltage */
	PROP_UINT16(
		"volt.1v0",
		SL_SRS4_PROP_TM_VOLT_1V0,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_VOLT_1V0_DEF_VAL,
		SL_SRS4_PROP_TM_VOLT_1V0_MIN_VAL,
		SL_SRS4_PROP_TM_VOLT_1V0_MAX_VAL,
		SL_SRS4_PROP_TM_VOLT_1V0_FMT,
		SL_SRS4_PROP_TM_VOLT_1V0_UNIT
	),
	/* tm.volt.pa: PA voltage */
	PROP_UINT16(
		"volt.pa",
		SL_SRS4_PROP_TM_VOLT_PA,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_VOLT_PA_DEF_VAL,
		SL_SRS4_PROP_TM_VOLT_PA_MIN_VAL,
		SL_SRS4_PROP_TM_VOLT_PA_MAX_VAL,
		SL_SRS4_PROP_TM_VOLT_PA_FMT,
		SL_SRS4_PROP_TM_VOLT_PA_UNIT
	),
	/* tm.cur.vin: Input current */
	PROP_INT16(
		"cur.vin",
		SL_SRS4_PROP_TM_CUR_VIN,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_CUR_VIN_DEF_VAL,
		SL_SRS4_PROP_TM_CUR_VIN_MIN_VAL,
		SL_SRS4_PROP_TM_CUR_VIN_MAX_VAL,
		SL_SRS4_PROP_TM_CUR_VIN_FMT,
		SL_SRS4_PROP_TM_CUR_VIN_UNIT
	),
	/* tm.cur.3v3: 3.3 V rail current */
	PROP_INT16(
		"cur.3v3",
		SL_SRS4_PROP_TM_CUR_3V3,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_CUR_3V3_DEF_VAL,
		SL_SRS4_PROP_TM_CUR_3V3_MIN_VAL,
		SL_SRS4_PROP_TM_CUR_3V3_MAX_VAL,
		SL_SRS4_PROP_TM_CUR_3V3_FMT,
		SL_SRS4_PROP_TM_CUR_3V3_UNIT
	),
	/* tm.cur.1v8: 1.8 V rail current */
	PROP_INT16(
		"cur.1v8",
		SL_SRS4_PROP_TM_CUR_1V8,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_CUR_1V8_DEF_VAL,
		SL_SRS4_PROP_TM_CUR_1V8_MIN_VAL,
		SL_SRS4_PROP_TM_CUR_1V8_MAX_VAL,
		SL_SRS4_PROP_TM_CUR_1V8_FMT,
		SL_SRS4_PROP_TM_CUR_1V8_UNIT
	),
	/* tm.cur.1v0: 1.0 V rail current */
	PROP_INT16(
		"cur.1v0",
		SL_SRS4_PROP_TM_CUR_1V0,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_CUR_1V0_DEF_VAL,
		SL_SRS4_PROP_TM_CUR_1V0_MIN_VAL,
		SL_SRS4_PROP_TM_CUR_1V0_MAX_VAL,
		SL_SRS4_PROP_TM_CUR_1V0_FMT,
		SL_SRS4_PROP_TM_CUR_1V0_UNIT
	),
	/* tm.cur.pa: PA current */
	PROP_INT16(
		"cur.pa",
		SL_SRS4_PROP_TM_CUR_PA,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_CUR_PA_DEF_VAL,
		SL_SRS4_PROP_TM_CUR_PA_MIN_VAL,
		SL_SRS4_PROP_TM_CUR_PA_MAX_VAL,
		SL_SRS4_PROP_TM_CUR_PA_FMT,
		SL_SRS4_PROP_TM_CUR_PA_UNIT
	),
	/* tm.power.vin: Input power */
	PROP_UINT16(
		"power.vin",
		SL_SRS4_PROP_TM_POWER_VIN,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_POWER_VIN_DEF_VAL,
		SL_SRS4_PROP_TM_POWER_VIN_MIN_VAL,
		SL_SRS4_PROP_TM_POWER_VIN_MAX_VAL,
		SL_SRS4_PROP_TM_POWER_VIN_FMT,
		SL_SRS4_PROP_TM_POWER_VIN_UNIT
	),
	/* tm.power.3v3: 3.3 V rail power */
	PROP_UINT16(
		"power.3v3",
		SL_SRS4_PROP_TM_POWER_3V3,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_POWER_3V3_DEF_VAL,
		SL_SRS4_PROP_TM_POWER_3V3_MIN_VAL,
		SL_SRS4_PROP_TM_POWER_3V3_MAX_VAL,
		SL_SRS4_PROP_TM_POWER_3V3_FMT,
		SL_SRS4_PROP_TM_POWER_3V3_UNIT
	),
	/* tm.power.1v8: 1.8 V rail power */
	PROP_UINT16(
		"power.1v8",
		SL_SRS4_PROP_TM_POWER_1V8,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_POWER_1V8_DEF_VAL,
		SL_SRS4_PROP_TM_POWER_1V8_MIN_VAL,
		SL_SRS4_PROP_TM_POWER_1V8_MAX_VAL,
		SL_SRS4_PROP_TM_POWER_1V8_FMT,
		SL_SRS4_PROP_TM_POWER_1V8_UNIT
	),
	/* tm.power.1v0: 1.0 V rail power */
	PROP_UINT16(
		"power.1v0",
		SL_SRS4_PROP_TM_POWER_1V0,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_POWER_1V0_DEF_VAL,
		SL_SRS4_PROP_TM_POWER_1V0_MIN_VAL,
		SL_SRS4_PROP_TM_POWER_1V0_MAX_VAL,
		SL_SRS4_PROP_TM_POWER_1V0_FMT,
		SL_SRS4_PROP_TM_POWER_1V0_UNIT
	),
	/* tm.power.pa: PA power */
	PROP_UINT16(
		"power.pa",
		SL_SRS4_PROP_TM_POWER_PA,
		PROP_FLAG_READONLY,
		SL_SRS4_PROP_TM_POWER_PA_DEF_VAL,
		SL_SRS4_PROP_TM_POWER_PA_MIN_VAL,
		SL_SRS4_PROP_TM_POWER_PA_MAX_VAL,
		SL_SRS4_PROP_TM_POWER_PA_FMT,
		SL_SRS4_PROP_TM_POWER_PA_UNIT
	),
};

/* Groups */
static const struct prop_group_spec srs4_prop_groups[] = {
	PROP_GROUP("sys", SL_SRS4_PROP_SYS_GROUP, srs4_sys_props, "System properties"),
	PROP_GROUP("cal", SL_SRS4_PROP_CAL_GROUP, srs4_cal_props, "Calibration properties"),
	PROP_GROUP("tx", SL_SRS4_PROP_TX_GROUP, srs4_tx_props, "Transmitter properties"),
	PROP_GROUP("rx", SL_SRS4_PROP_RX_GROUP, srs4_rx_props, "Receiver properties"),
	PROP_GROUP("tm", SL_SRS4_PROP_TM_GROUP, srs4_tm_props, "Telemetry properties"),
};

/* Subsystem */
const struct prop_subsys_spec srs4_props =
	PROP_SUBSYSTEM("srs4", "Satlab SRS-4 S-band radio", srs4_prop_groups);
