/**
 * @file comms_uhf_api_map.h
 *
 * @brief This file contains API mapping of various S-Band module/S_Band simulation
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0(the "License");
 *you may not use this file except in compliance with the License.
 *you may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*
*/

#ifndef COMMS_UHF_API_MAP_H_
#define COMMS_UHF_API_MAP_H_

#include<comms_uhf_main.h>
#include<comms_uhf_sim.h>

#ifndef UHF_SIM_CB

/**
* @brief These are Macros used for programming API mapping of SRS4 S-Band module.
*
*/

#define SDR_UHF_FIRMWARE_CFG(x)                   sdr_uhf_firmware_cfg(x)
#define SDR_UHF_GET_TM_PROP(x,y)                  sdr_uhf_get_tm_prop(x,y)
#define SDR_UHF_GET_CSP_TM_PROP(x,y)              sdr_get_csp_tm_prop(x,y)

#else

/**
* @brief These are Macros used for programming API mapping of S-Band simulation module.
*
*/

#define SDR_UHF_FIRMWARE_CFG(x)                   sdr_uhf_sim_firmware_cfg(x)
#define SDR_UHF_GET_TM_PROP(x,y)                  sdr_uhf_sim_get_tm_prop(x,y)
#define SDR_UHF_GET_CSP_TM_PROP(x,y)              sdr_get_csp_tm_prop(x,y)

#endif

#endif /*COMMS_UHF_API_MAP_H_*/
