/**
 * @file ft_sender.h
 *
 * @brief This file contains function prototypes of state machine handler function
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/

#ifndef FT_SENDER_H_
#define FT_SENDER_H_

#include "segmentation.h"
#include "tc_tm_sample.h"

#define FT_SESSION_ID_INC      0
#define FT_SESSION_ID_DEC      1
#define FT_SESSION_ID_CLR      2
#define FT_SESSION_ID_MAX      7


/******************************************************************************/
/*               Declaration of exported function prototypes                  */
/******************************************************************************/

/**
 * @brief State Machine :Function that handles data transmission and input collecting
 *
 *
 * @param[in]  none
 *
 * @return none
 * @retval void
 */
void ft_statemachine_upload(void);
void ft_tx_session_id_update(uint8 option);
uint8_t ft_tx_session_id_read(void);

#endif /* FT_SENDER_H_ */
