/*
 * @file ft_timer.h
 *
 * @brief This file contains function prototypes for file tranfer internal timer. 
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#ifndef _FT_TIMER_H_
#define _FT_TIMER_H_

//#include "common.h"
#include "exo_lib/file_transfer/inc/common.h"

/******************************************************************************/
/*                Definition of exported function like macros                 */
/******************************************************************************/

/*
 * Configure periodicity of FTM handler thread in milliseconds
 */
#define FT_HANDLER_DELAY_MS 1
#define FT_TICK_TIME_IN_SEC (1000 / FT_HANDLER_DELAY_MS)


/******************************************************************************/
/*               Declaration of exported function prototypes                  */
/******************************************************************************/

void ft_update_timer(void);
void ft_reset_timer(void);
void ft_set_timer(uint16_t set);
void ft_stop_timer();
uint8_t ft_get_flag(void);
void ft_init_timer(void);
uint16_t ft_get_previous_timer(void);


#endif /* _FT_TIMER_H_ */
