/**
 *@file ftci_decode.h
 *
 *@brief This file contains function prototypes and data definitions that
 *helps to decode FTSI frame received from sender node
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef FTCI_DECODE_H_
#define FTCI_DECODE_H_

#include "download_def.h"

/******************************************************************************/
/*                    Declaration of exported variables                       */
/******************************************************************************/

extern s_treceive_info dwnld_rqst;
extern s_treceive_info resume_ctxt_rqst;



/******************************************************************************/
/*               Declaration of exported function prototypes                  */
/******************************************************************************/

/**
 * @brief This API receives the FTCI frame data from TC-TM then decode FTCI frame
 *
 *
 * @param[in]  ftci_data  : pointer to received FTCI frame
 * @param[in]  ftci_data_length  : frame length
 *
 * @return none
 * @retval void : none
 *
 */
void ft_receive_ftci(uint8_t *ftci_data, uint16_t ftci_data_length);



#endif /*FTCI_DECODE_H_ */
