/*
 * @file adcs_ftm.h
 *
 * @brief This file contains file transfer manager related functions for ADCS
 *
 * @copyright Copyright 2023 Antaris, Inc.
 */

#ifndef ADCS_FTM_H_
#define ADCS_FTM_H_

#include "notify_apps.h"

/*
 * @brief Application API which will be invoked during file transmission by FT
 * framework it handles all FTM related notification published by FTM module
 *
 * @param[in] ft_sts:       FTM handle
 */
void adcs_ft_receiver_notificataion_clbk(ft_notification_info *ft_sts);

/*
 * @brief This API register FTM service for ADCS
 */
void adcs_fw_init(void);

#endif /* ADCS_FTM_H_ */
