/**
 * @file comms_uhf_ftm.h
 *
 * @brief This file has the function prototypes of S-Band firmware file transfer
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef _INC_COMMS_UHF_FTM_H_
#define _INC_COMMS_UHF_FTM_H_



#include "file_transfer.h"
#include "notify_apps.h"

/**
* @brief Application API which will be invoked during file transmission by FT
*  framework it handles all FTM related notification published by FTM module
*
* @param ft_sts : pointer to file transmission status
*/
void comms_uhf_ft_receiver_notificataion_clbk(ft_notification_info *ft_sts);
/**
* @brief It should be called in initialization of thread, it should not be
* called before the FTM module initialization routine has not complete
*/
void comms_uhf_ftm_init(void);




#endif /* _INC_COMMS_UHF_FTM_H_ */
