/*
 * @file flash_sector.h
 *
 * @brief This file contains function definitions for OTSU flash sector.
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#ifndef FLASH_SECTOR_H_
#define FLASH_SECTOR_H_



#include "stdint.h"

/**
 * @brief This function used to identify which sector the input address belongs..
 *
 * @param[in]  Address : Input flash address
 *
 * @return sector number
 * @retval sector number in th erange of 0 -23
 */
uint32_t GetSector(uint32_t Address);

void flash_sector_init(void);
uint32_t sector_serach(uint8_t);

#endif /* FLASH_SECTOR_H_ */
