/**
  ******************************************************************************
  * @file      startup_stm32f769xx.s
  * @author    MCD Application Team
  * @brief     STM32F769xx Devices vector table for GCC based toolchain. 
  *            This module performs:
  *                - Set the initial SP
  *                - Set the initial PC == Reset_Handler,
  *                - Set the vector table entries with the exceptions ISR address
  *                - Branches to main in the C library (which eventually
  *                  calls main()).
  *            After Reset the Cortex-M7 processor is in Thread mode,
  *            priority is Privileged, and the Stack is set to Main.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2016 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
    
  .syntax unified
  .cpu cortex-m7
  .fpu softvfp
  .thumb


.global  g_pfnVectors_otsu


  .section  .module_init_section,"a",%progbits
  .type  g_pfnVectors_otsu, %object
  .size  g_pfnVectors_otsu, .-g_pfnVectors_otsu

g_pfnVectors_otsu:
  .word  bin_init
  .word  bin_init
  .word  bin_init
  .word  bin_init


