/**
 * @file ftm_version.h
 *
 * @brief This file contains the software version
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef FTM_VERSION_H_
#define FTM_VERSION_H_


#include "stdint.h"
/*---------------------------------------------------------------------------*/
/*  Description : Software Version   : Major and Minor version                                        */
/*  Format: Hex    >> example: sw version 1.8 will be denoted as 0x01 major and 0x08 minor                                                          */
/*---------------------------------------------------------------------------*/
#define FTM_VER_u8DATA_SW_MAJOR                                   (uint8_t) 1
#define FTM_VER_u8DATA_SW_MINOR                                   (uint8_t) 12


void FTM_vidGetVersionInfo(uint8_t versioninfo[]);


#endif /* FTM_VERSION_H_ */

