#ifndef _TC_TM_SAMPLE_H_
#define _TC_TM_SAMPLE_H_

/**
 *  *  @brief  Data Type definitions
 *   */
typedef unsigned int uint32;
typedef unsigned short uint16;
typedef unsigned char uint8;

typedef int int32;
typedef short int16;
typedef char int8;

/**
 *  @brief  TCTM Encoder Decoder API Execution status macros
 */
#define TCTM_OK                   (0)      ///< Success return value
#define TCTM_NULL_PTR             (-1)     ///< Null pointer return value

/*!
 *  @brief This enum holds the enumeration values of TC and TM ID
 */
typedef enum _tc_tm_id_ft
{

	/*
	 *
	// File Transfer
    TC_FTCI = 100,
    TM_FTSR = 101,
    TC_FTDS = 102,
    TC_FTFCI = 103,

    TM_FTCI = 104,
    TC_FTSR = 105,
    TM_FTDS = 106,
    TM_FTFCI = 107,
	 *
	 */



	FT_TC_FTCI = 100,   // GS sender
	FT_TM_FTSR,  // SAT response to GS
	FT_TC_FTDS,   // GS sender
	FT_TC_FTFCI,  // GS sender

	FT_TM_FTCI,  // SAT sender
	FT_TC_FTSR,   // GS response to SAT
	FT_TM_FTDS,  // SAT sender
	FT_TM_FTFCI, // SAT sender

	FT_TC_FTDB   = 563,
	FT_TM_FTDR    = 564,

	FT_TC_FTDR   = 578,
	FT_TM_FTDB    = 579,

	FT_TC_TM_MAX_ID = 0

}tc_tm_id_e_ft;

#endif
