/**
 * @file version.c
 *
 * @brief This file contains the software version
 *
 * @copyright Copyright 2023 Antaris, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "ftm_version.h"
#include "string.h"


/*---------------------------------------------------------------------------*/
/*   Index of table                                                          */
/*---------------------------------------------------------------------------*/

const uint8_t ftm_software_Version[2] =
{
  /* FTM Version Major */
  (uint8_t) FTM_VER_u8DATA_SW_MAJOR,
  /* FTM Version Minor */
  (uint8_t) FTM_VER_u8DATA_SW_MINOR
};

/*---------------------------------------------------------------------------*/
/* !Description :                                                            */
/*      Get the version of the FTM Software                                  */
/*---------------------------------------------------------------------------*/
void FTM_vidGetVersionInfo(uint8_t versioninfo[])
{
  /* !Pseudo : copy all data */
  memcpy(versioninfo,ftm_software_Version,(uint8_t)2);
}
