//C program to implement
// the above approach
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Structure to store
// socket details
struct sock_info {
    char ip_addr[16];
    char port_num[5];
};

// Driver code
int main()
{
    FILE* of;

    ////////////////////////////////////////////////
    // Generate socket configuration file for OBC
    ////////////////////////////////////////////////
    of = fopen("obc_soc_cfg.txt", "w");
    if (of == NULL) {
        fprintf(stderr,
                "\nError to open the file\n");
        exit(1);
    }

    struct sock_info obc_tc_addr = { "192.168.10.1","5001" };
    struct sock_info obc_tm_addr = { "192.168.10.1","5002" };
    struct sock_info obc_icd_tx_addr = { "192.168.10.1","5003" };
    struct sock_info obc_icd_rx_addr = { "192.168.10.1","5004" };
    fwrite(&obc_tc_addr, sizeof(struct sock_info),1, of);
    fwrite(&obc_tm_addr, sizeof(struct sock_info),1, of);
    fwrite(&obc_icd_tx_addr, sizeof(struct sock_info),1, of);
    fwrite(&obc_icd_rx_addr, sizeof(struct sock_info),1, of);
    if (fwrite != 0)
        printf("Contents to file written successfully !\n");
    else
        printf("Error writing file !\n");
    fclose(of);

    /*
    int port = atoi(obc_tc_addr.port_num);
    unsigned int ip_addr = inet_addr(obc_tc_addr.ip_addr);
    printf("Port number is %d\n",port);
    printf("IP address is %d\n",ip_addr); */

    /////////////////////////////////////////////
    // Generate socket configuration file for PS
    /////////////////////////////////////////////
    of = fopen("ps_soc_cfg.txt", "w");
    if (of == NULL) {
        fprintf(stderr,
                "\nError to open the file\n");
        exit(1);
    }

    struct sock_info ps_icd_tx_addr = { "192.168.10.1","5004" };
    struct sock_info ps_icd_rx_addr = { "192.168.10.1","5003" };
    fwrite(&ps_icd_tx_addr, sizeof(struct sock_info),1, of);
    fwrite(&ps_icd_rx_addr, sizeof(struct sock_info),1, of);
    if (fwrite != 0)
        printf("Contents to file written successfully !\n");
    else
        printf("Error writing file !\n");
    fclose(of);

    /////////////////////////////////////////////
    // Generate socket configuration file for GS
    /////////////////////////////////////////////
    of = fopen("gs_soc_cfg.txt", "w");
    if (of == NULL) {
        fprintf(stderr,
                "\nError to open the file\n");
        exit(1);
    }

    struct sock_info gs_tc_addr = { "192.168.10.1","5001" };
    struct sock_info gs_tm_addr = { "192.168.10.1","5002" };
    fwrite(&gs_tc_addr, sizeof(struct sock_info),1, of);
    fwrite(&gs_tm_addr, sizeof(struct sock_info),1, of);
    if (fwrite != 0)
        printf("Contents to file written successfully !\n");
    else
        printf("Error writing file !\n");
    fclose(of);

    /////////////////////////////////////////////
    // Reading socket configuration for OBC
    /////////////////////////////////////////////
    // File pointer to read from file
    FILE* inf;
    struct sock_info soc_inf;
    inf = fopen("obc_soc_cfg.txt", "r");

    if (inf == NULL) {
        fprintf(stderr,
                "\nError to open the file\n");
        exit(1);
    }

    fread(&soc_inf, sizeof(struct sock_info),1, inf);
    unsigned int obc_tc_soc_ip_addr = inet_addr(soc_inf.ip_addr);
    unsigned int obc_tc_soc_port_num = atoi(soc_inf.port_num);
    printf("OBC TC socket address is %u %u\n",obc_tc_soc_ip_addr,obc_tc_soc_port_num);

    fread(&soc_inf, sizeof(struct sock_info),1, inf);
    unsigned int obc_tm_soc_ip_addr = inet_addr(soc_inf.ip_addr);
    unsigned int obc_tm_soc_port_num = atoi(soc_inf.port_num);
    printf("OBC TM socket address is %u %u\n",obc_tm_soc_ip_addr,obc_tm_soc_port_num);

    fread(&soc_inf, sizeof(struct sock_info),1, inf);
    unsigned int obc_icd_tx_soc_ip_addr = inet_addr(soc_inf.ip_addr);
    unsigned int obc_icd_tx_soc_port_num = atoi(soc_inf.port_num);
    printf("OBC TM socket address is %u %u\n",obc_icd_tx_soc_ip_addr,obc_icd_tx_soc_port_num);

    fread(&soc_inf, sizeof(struct sock_info),1, inf);
    unsigned int obc_icd_rx_soc_ip_addr = inet_addr(soc_inf.ip_addr);
    unsigned int obc_icd_rx_soc_port_num = atoi(soc_inf.port_num);
    printf("OBC TM socket address is %u %u\n",obc_icd_rx_soc_ip_addr,obc_icd_rx_soc_port_num);

    fclose(inf);


    /////////////////////////////////////////////
    // Reading socket configuration for PS ICD
    /////////////////////////////////////////////
    // File pointer to read from file
    inf = fopen("ps_soc_cfg.txt", "r");

    if (inf == NULL) {
        fprintf(stderr,
                "\nError to open the file\n");
        exit(1);
    }

    fread(&soc_inf, sizeof(struct sock_info),1, inf);
    unsigned int ps_icd_tx_soc_ip_addr = inet_addr(soc_inf.ip_addr);
    unsigned int ps_icd_tx_soc_port_num = atoi(soc_inf.port_num);
    printf("PS ICD TX socket address is %u %u\n",ps_icd_tx_soc_ip_addr,ps_icd_tx_soc_port_num);

    fread(&soc_inf, sizeof(struct sock_info),1, inf);
    unsigned int ps_icd_rx_soc_ip_addr = inet_addr(soc_inf.ip_addr);
    unsigned int ps_icd_rx_soc_port_num = atoi(soc_inf.port_num);
    printf("PS ICD RX socket address is %u %u\n",ps_icd_rx_soc_ip_addr,ps_icd_rx_soc_port_num);

    fclose(inf);

    /////////////////////////////////////////////
    // Reading socket configuration for GS TCTM
    /////////////////////////////////////////////
    // File pointer to read from file
    inf = fopen("gs_soc_cfg.txt", "r");

    if (inf == NULL) {
        fprintf(stderr,
                "\nError to open the file\n");
        exit(1);
    }

    fread(&soc_inf, sizeof(struct sock_info),1, inf);
    unsigned int gs_tc_soc_ip_addr = inet_addr(soc_inf.ip_addr);
    unsigned int gs_tc_soc_port_num = atoi(soc_inf.port_num);
    printf("GS TC socket address is %u %u\n",gs_tc_soc_ip_addr,gs_tc_soc_port_num);

    fread(&soc_inf, sizeof(struct sock_info),1, inf);
    unsigned int gs_tm_soc_ip_addr = inet_addr(soc_inf.ip_addr);
    unsigned int gs_tm_soc_port_num = atoi(soc_inf.port_num);
    printf("GS TM socket address is %u %u\n",gs_tm_soc_ip_addr,gs_tm_soc_port_num);

    fclose(inf);
}
